/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.3.0(634ebbb12334e179e98d3f53c3a367443f11f3ea)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
define("vs/base/common/diff/diffChange",["require","exports"],function(e,t){"use strict";t.DifferenceType={Add:0,Remove:1,Change:2};var n=function(){function e(e,t,n,r){this.originalStart=e,this.originalLength=t,this.modifiedStart=n,this.modifiedLength=r}return e.prototype.getChangeType=function(){return 0===this.originalLength?t.DifferenceType.Add:0===this.modifiedLength?t.DifferenceType.Remove:t.DifferenceType.Change},e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();t.DiffChange=n}),define("vs/base/common/diff/diff",["require","exports","vs/base/common/diff/diffChange"],function(e,t,n){"use strict";var r=function(){function e(){}return e.Assert=function(e,t){if(!e)throw new Error(t)},e}();t.Debug=r;var i=function(){function e(){}return e.Copy=function(e,t,n,r,i){for(var o=0;i>o;o++)n[r+o]=e[t+o]},e}();t.MyArray=i;var o=1447,s=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new n.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_originalCount++},e.prototype.AddModifiedElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),a=function(){function e(e,t,n){void 0===n&&(n=null),this.OriginalSequence=e,this.ModifiedSequence=t,this.ContinueProcessingPredicate=n,this.m_originalIds=[],this.m_modifiedIds=[],this.m_forwardHistory=[],this.m_reverseHistory=[],this.ComputeUniqueIdentifiers()}return e.prototype.ComputeUniqueIdentifiers=function(){var e=this.OriginalSequence.getLength(),t=this.ModifiedSequence.getLength();this.m_originalIds=new Array(e),this.m_modifiedIds=new Array(t);var n,r={},i=1;for(n=0;e>n;n++){var o=this.OriginalSequence.getElementHash(n);r.hasOwnProperty(o)?this.m_originalIds[n]=r[o]:(this.m_originalIds[n]=i++,r[o]=this.m_originalIds[n])}for(n=0;t>n;n++){var s=this.ModifiedSequence.getElementHash(n);r.hasOwnProperty(s)?this.m_modifiedIds[n]=r[s]:(this.m_modifiedIds[n]=i++,r[s]=this.m_modifiedIds[n])}},e.prototype.ElementsAreEqual=function(e,t){return this.m_originalIds[e]===this.m_modifiedIds[t]},e.prototype.ComputeDiff=function(){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1)},e.prototype._ComputeDiff=function(e,t,n,r){var i=[!1];return this.ComputeDiffRecursive(e,t,n,r,i)},e.prototype.ComputeDiffRecursive=function(e,t,i,o,s){for(s[0]=!1;t>=e&&o>=i&&this.ElementsAreEqual(e,i);)e++,i++;for(;t>=e&&o>=i&&this.ElementsAreEqual(t,o);)t--,o--;if(e>t||i>o){var a=void 0;return o>=i?(r.Assert(e===t+1,"originalStart should only be one more than originalEnd"),a=[new n.DiffChange(e,0,i,o-i+1)]):t>=e?(r.Assert(i===o+1,"modifiedStart should only be one more than modifiedEnd"),a=[new n.DiffChange(e,t-e+1,i,0)]):(r.Assert(e===t+1,"originalStart should only be one more than originalEnd"),r.Assert(i===o+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}var u=[0],c=[0],l=this.ComputeRecursionPoint(e,t,i,o,u,c,s),h=u[0],f=c[0];if(null!==l)return l;if(!s[0]){var d=this.ComputeDiffRecursive(e,h,i,f,s),m=[];return m=s[0]?[new n.DiffChange(h+1,t-(h+1)+1,f+1,o-(f+1)+1)]:this.ComputeDiffRecursive(h+1,t,f+1,o,s),this.ConcatenateChanges(d,m)}return[new n.DiffChange(e,t-e+1,i,o-i+1)]},e.prototype.WALKTRACE=function(e,t,r,i,o,a,u,c,l,h,f,d,m,p,g,v,_,b){var C,y=null,x=null,L=new s,N=t,S=r,E=m[0]-v[0]-i,k=Number.MIN_VALUE,I=this.m_forwardHistory.length-1;do C=E+e,C===N||S>C&&l[C-1]<l[C+1]?(f=l[C+1],p=f-E-i,k>f&&L.MarkNextChange(),k=f,L.AddModifiedElement(f+1,p),E=C+1-e):(f=l[C-1]+1,p=f-E-i,k>f&&L.MarkNextChange(),k=f-1,L.AddOriginalElement(f,p+1),E=C-1-e),I>=0&&(l=this.m_forwardHistory[I],e=l[0],N=1,S=l.length-1);while(--I>=-1);if(y=L.getReverseChanges(),b[0]){var w=m[0]+1,A=v[0]+1;if(null!==y&&y.length>0){var R=y[y.length-1];w=Math.max(w,R.getOriginalEnd()),A=Math.max(A,R.getModifiedEnd())}x=[new n.DiffChange(w,d-w+1,A,g-A+1)]}else{L=new s,N=a,S=u,E=m[0]-v[0]-c,k=Number.MAX_VALUE,I=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do C=E+o,C===N||S>C&&h[C-1]>=h[C+1]?(f=h[C+1]-1,p=f-E-c,f>k&&L.MarkNextChange(),k=f+1,L.AddOriginalElement(f+1,p+1),E=C+1-o):(f=h[C-1],p=f-E-c,f>k&&L.MarkNextChange(),k=f,L.AddModifiedElement(f+1,p+1),E=C-1-o),I>=0&&(h=this.m_reverseHistory[I],o=h[0],N=1,S=h.length-1);while(--I>=-1);x=L.getChanges()}return this.ConcatenateChanges(y,x)},e.prototype.ComputeRecursionPoint=function(e,t,r,s,a,u,c){var l,h,f,d=0,m=0,p=0,g=0;e--,r--,a[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var v=t-e+(s-r),_=v+1,b=new Array(_),C=new Array(_),y=s-r,x=t-e,L=e-r,N=t-s,S=x-y,E=S%2===0;b[y]=e,C[x]=t,c[0]=!1;var k,I;for(f=1;v/2+1>=f;f++){var w=0,A=0;for(d=this.ClipDiagonalBound(y-f,f,y,_),m=this.ClipDiagonalBound(y+f,f,y,_),k=d;m>=k;k+=2){for(l=k===d||m>k&&b[k-1]<b[k+1]?b[k+1]:b[k-1]+1,h=l-(k-y)-L,I=l;t>l&&s>h&&this.ElementsAreEqual(l+1,h+1);)l++,h++;if(b[k]=l,l+h>w+A&&(w=l,A=h),!E&&Math.abs(k-x)<=f-1&&l>=C[k])return a[0]=l,u[0]=h,I<=C[k]&&o>0&&o+1>=f?this.WALKTRACE(y,d,m,L,x,p,g,N,b,C,l,t,a,h,s,u,E,c):null}var R=(w-e+(A-r)-f)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(w,this.OriginalSequence,R))return c[0]=!0,a[0]=w,u[0]=A,R>0&&o>0&&o+1>=f?this.WALKTRACE(y,d,m,L,x,p,g,N,b,C,l,t,a,h,s,u,E,c):(e++,r++,[new n.DiffChange(e,t-e+1,r,s-r+1)]);for(p=this.ClipDiagonalBound(x-f,f,x,_),g=this.ClipDiagonalBound(x+f,f,x,_),k=p;g>=k;k+=2){for(l=k===p||g>k&&C[k-1]>=C[k+1]?C[k+1]-1:C[k-1],h=l-(k-x)-N,I=l;l>e&&h>r&&this.ElementsAreEqual(l,h);)l--,h--;if(C[k]=l,E&&Math.abs(k-y)<=f&&l<=b[k])return a[0]=l,u[0]=h,I>=b[k]&&o>0&&o+1>=f?this.WALKTRACE(y,d,m,L,x,p,g,N,b,C,l,t,a,h,s,u,E,c):null}if(o>=f){var T=new Array(m-d+2);T[0]=y-d+1,i.Copy(b,d,T,1,m-d+1),this.m_forwardHistory.push(T),T=new Array(g-p+2),T[0]=x-p+1,i.Copy(C,p,T,1,g-p+1),this.m_reverseHistory.push(T)}}return this.WALKTRACE(y,d,m,L,x,p,g,N,b,C,l,t,a,h,s,u,E,c)},e.prototype.ConcatenateChanges=function(e,t){var n=[],r=null;return 0===e.length||0===t.length?t.length>0?t:e:this.ChangesOverlap(e[e.length-1],t[0],n)?(r=new Array(e.length+t.length-1),i.Copy(e,0,r,0,e.length-1),r[e.length-1]=n[0],i.Copy(t,1,r,e.length,t.length-1),r):(r=new Array(e.length+t.length),i.Copy(e,0,r,0,e.length),i.Copy(t,0,r,e.length,t.length),r)},e.prototype.ChangesOverlap=function(e,t,i){if(r.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),r.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){var o=e.originalStart,s=e.originalLength,a=e.modifiedStart,u=e.modifiedLength;return e.originalStart+e.originalLength>=t.originalStart&&(s=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(u=t.modifiedStart+t.modifiedLength-e.modifiedStart),i[0]=new n.DiffChange(o,s,a,u),!0}return i[0]=null,!1},e.prototype.ClipDiagonalBound=function(e,t,n,r){if(e>=0&&r>e)return e;var i=n,o=r-n-1,s=t%2===0;if(0>e){var a=i%2===0;return s===a?0:1}var u=o%2===0;return s===u?r-1:r-2},e}();t.LcsDiff=a}),define("vs/base/common/paths",["require","exports","vs/base/common/platform"],function(e,t,n){"use strict";function r(e,n){e=u(e),n=u(n);for(var r=e.split(t.sep),i=n.split(t.sep);r.length>0&&i.length>0&&r[0]===i[0];)r.shift(),i.shift();for(var o=0,s=r.length;s>o;o++)i.unshift("..");return i.join(t.sep)}function i(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?".":0===~t?e[0]:e.substring(0,~t)}function o(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?e:~t===e.length-1?o(e.substring(0,e.length-1)):e.substr(~t+1)}function s(e){e=o(e);var t=~e.lastIndexOf(".");return t?e.substring(~t):""}function a(e,t){return t?!_.test(e):!v.test(e)}function u(e,t){if(null===e||void 0===e)return e;var r=e.length;if(0===r)return".";var i=n.isWindows&&t;if(a(e,i))return e;for(var o=i?"\\":"/",s=l(e,o),u=s.length,h=!1,f="",d=s.length;r>=d;d++)if(d===r||e.charCodeAt(d)===b||e.charCodeAt(d)===C){if(c(e,u,d,"..")){var m=f.lastIndexOf(o),p=f.slice(m+1);(s||p.length>0)&&".."!==p&&(f=-1===m?"":f.slice(0,m),h=!0)}else c(e,u,d,".")&&(s||f||r-1>d)&&(h=!0);if(!h){var g=e.slice(u,d);""!==f&&f[f.length-1]!==o&&(f+=o),f+=g}u=d+1,h=!1}return s+f}function c(e,t,n,r){return t+r.length===n&&e.indexOf(r,t)===t}function l(e,t){if(void 0===t&&(t="/"),!e)return"";var n=e.length,r=e.charCodeAt(0);if(r===b||r===C){if(r=e.charCodeAt(1),(r===b||r===C)&&(r=e.charCodeAt(2),r!==b&&r!==C)){for(var i=3,o=i;n>i&&(r=e.charCodeAt(i),r!==b&&r!==C);i++);if(r=e.charCodeAt(i+1),o!==i&&r!==b&&r!==C)for(i+=1;n>i;i++)if(r=e.charCodeAt(i),r===b||r===C)return e.slice(0,i+1).replace(/[\\/]/g,t)}return t}if((r>=L&&S>=r||r>=x&&N>=r)&&e.charCodeAt(1)===y)return r=e.charCodeAt(2),r===b||r===C?e.slice(0,2)+t:e.slice(0,2);var s=e.indexOf("://");if(-1!==s)for(s+=3;n>s;s++)if(r=e.charCodeAt(s),r===b||r===C)return e.slice(0,s+1);return""}function h(e){if(!n.isWindows)return!1;if(!e||e.length<5)return!1;var t=e.charCodeAt(0);if(t!==C)return!1;if(t=e.charCodeAt(1),t!==C)return!1;for(var r=2,i=r;r<e.length&&(t=e.charCodeAt(r),t!==C);r++);return i===r?!1:(t=e.charCodeAt(r+1),!isNaN(t)&&t!==C)}function f(e){return e&&"/"===e[0]}function d(e){return f(u(e))?e:t.sep+e}function m(e,t){if(e===t)return!0;e=u(e),t=u(t);var r=t.length,i=t.charCodeAt(r-1);if(i===b&&(t=t.substring(0,r-1),r-=1),e===t)return!0;if(n.isLinux||(e=e.toLowerCase(),t=t.toLowerCase()),e===t)return!0;if(0!==e.indexOf(t))return!1;var o=e.charCodeAt(r);return o===b}function p(e){return!e||0===e.length||/^\s+$/.test(e)?!1:(E.lastIndex=0,E.test(e)?!1:n.isWindows&&k.test(e)?!1:"."===e||".."===e?!1:n.isWindows&&"."===e[e.length-1]?!1:!n.isWindows||e.length===e.trim().length)}function g(e){return t.isAbsoluteRegex.test(e)}t.sep="/",t.nativeSep=n.isWindows?"\\":"/",t.relative=r,t.dirname=i,t.basename=o,t.extname=s;var v=/(\/\.\.?\/)|(\/\.\.?)$|^(\.\.?\/)|(\/\/+)|(\\)/,_=/(\\\.\.?\\)|(\\\.\.?)$|^(\.\.?\\)|(\\\\+)|(\/)/;t.normalize=u,t.getRoot=l,t.join=function(){for(var e="",n=0;n<arguments.length;n++){var r=arguments[n];if(n>0){var i=e.charCodeAt(e.length-1);if(i!==b&&i!==C){var o=r.charCodeAt(0);o!==b&&o!==C&&(e+=t.sep)}}e+=r}return u(e)},t.isUNC=h,t.makePosixAbsolute=d;var b="/".charCodeAt(0),C="\\".charCodeAt(0),y=":".charCodeAt(0),x="a".charCodeAt(0),L="A".charCodeAt(0),N="z".charCodeAt(0),S="Z".charCodeAt(0);t.isEqualOrParent=m;var E=n.isWindows?/[\\/:\*\?"<>\|]/g:/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])$/i;t.isValidBasename=p,t.isAbsoluteRegex=/^((\/|[a-zA-Z]:\\)[^\(\)<>\\'\"\[\]]+)/,t.isAbsolute=g}),define("vs/base/common/filters",["require","exports","vs/base/common/strings","vs/base/common/map"],function(e,t,n,r){"use strict";function i(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=0,i=e.length;i>r;r++){var o=e[r](t,n);if(o)return o}return null}}function o(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=[],i=0,o=e.length;o>i;i++){var s=e[i](t,n);if(!s)return null;r=r.concat(s)}return r}}function s(e,t,n){if(!n||0===n.length||n.length<t.length)return null;e&&(t=t.toLowerCase(),n=n.toLowerCase());for(var r=0;r<t.length;r++)if(t[r]!==n[r])return null;return t.length>0?[{start:0,end:t.length}]:[]}function a(e,t){var n=t.toLowerCase().indexOf(e.toLowerCase());return-1===n?null:[{start:n,end:n+e.length}]}function u(e,t){return c(e.toLowerCase(),t.toLowerCase(),0,0)}function c(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]===t[r]){var i=null;if(i=c(e,t,n+1,r+1))return p({start:r,end:r+1},i)}return c(e,t,n,r+1)}function l(e){return e>=97&&122>=e}function h(e){return e>=65&&90>=e}function f(e){return e>=48&&57>=e}function d(e){return[32,9,10,13].indexOf(e)>-1}function m(e){return l(e)||h(e)||f(e)}function p(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function g(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(h(r)||f(r)||n>0&&!m(e.charCodeAt(n-1)))return n}return e.length}function v(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var i=null,o=r+1;for(i=v(e,t,n+1,r+1);!i&&(o=g(t,o))<t.length;)i=v(e,t,n+1,o),o++;return null===i?null:p({start:r,end:r+1},i)}function _(e){if(e.length>60)return!1;for(var t=0,n=0,r=0,i=0,o=0,s=0;s<e.length;s++)o=e.charCodeAt(s),h(o)&&t++,l(o)&&n++,m(o)&&r++,f(o)&&i++;var a=t/e.length,u=n/e.length,c=r/e.length,d=i/e.length;return u>.2&&.8>a&&c>.6&&.2>d}function b(e){for(var t=0,n=0,r=0,i=0,o=0;o<e.length;o++)r=e.charCodeAt(o),h(r)&&t++,l(r)&&n++,d(r)&&i++;return 0!==t&&0!==n||0!==i?5>=t:e.length<=30}function C(e,t){if(!t||0===t.length)return null;if(!b(e))return null;if(!_(t))return null;for(var n=null,r=0;r<t.length&&null===(n=v(e.toLowerCase(),t,0,r));)r=g(t,r+1);return n}function y(e,t){if(!t||0===t.length)return null;for(var n=null,r=0;r<t.length&&null===(n=x(e.toLowerCase(),t,0,r));)r=L(t,r+1);return n}function x(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var i=null,o=r+1;for(i=x(e,t,n+1,r+1);!i&&(o=L(t,o))<t.length;)i=x(e,t,n+1,o),o++;return null===i?null:p({start:r,end:r+1},i)}function L(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(d(r)||n>0&&d(e.charCodeAt(n-1)))return n}return e.length}function N(e,r,i){if(void 0===i&&(i=!1),"string"!=typeof e||"string"!=typeof r)return null;var o=E.get(e);o||(o=new RegExp(n.convertSimple2RegExpPattern(e),"i"),E.set(e,o));var s=o.exec(r);return s?[{start:s.index,end:s.index+s[0].length}]:i?S(e,r):t.fuzzyContiguousFilter(e,r)}t.or=i,t.and=o,t.matchesStrictPrefix=function(e,t){return s(!1,e,t)},t.matchesPrefix=function(e,t){return s(!0,e,t)},t.matchesContiguousSubString=a,t.matchesSubString=u,t.matchesCamelCase=C,t.matchesWords=y,function(e){e[e.Contiguous=0]="Contiguous",e[e.Separate=1]="Separate"}(t.SubstringMatching||(t.SubstringMatching={}));t.SubstringMatching;t.fuzzyContiguousFilter=i(t.matchesPrefix,C,a);var S=i(t.matchesPrefix,C,u),E=new r.LinkedMap(1e4);t.matchesFuzzy=N}),define("vs/base/common/glob",["require","exports","vs/base/common/strings","vs/base/common/paths","vs/base/common/map"],function(e,t,n,r,i){"use strict";function o(e){switch(e){case 0:return"";case 1:return d+"*?";default:return"(?:"+f+"|"+d+"+"+f+"|"+f+d+"+)*?"}}function s(e,t){if(!e)return[];for(var n,r=[],i=!1,o=!1,s="",a=0;a<e.length;a++){switch(n=e[a]){case t:if(!i&&!o){r.push(s),s="";continue}break;case"{":i=!0;break;case"}":i=!1;break;case"[":o=!0;break;case"]":o=!1}s+=n}return s&&r.push(s),r}function a(e){if(!e)return"";var t="",r=s(e,"/");if(r.every(function(e){return"**"===e}))t=".*";else{var i=!1;r.forEach(function(e,u){if("**"===e)return void(i||(t+=o(2),i=!0));for(var c,l=!1,h="",m=!1,p="",g=0;g<e.length;g++)if(c=e[g],"}"!==c&&l)h+=c;else if("]"!==c&&m){var v=void 0;switch(c){case"-":v=c;break;case"^":v=c;break;default:v=n.escapeRegExpCharacters(c)}p+=v}else switch(c){case"{":l=!0;continue;case"[":m=!0;continue;case"}":var _=s(h,","),b="(?:"+_.map(function(e){return a(e)}).join("|")+")";t+=b,l=!1,h="";break;case"]":t+="["+p+"]",m=!1,p="";break;case"?":t+=d;continue;case"*":t+=o(1);continue;default:t+=n.escapeRegExpCharacters(c)}u<r.length-1&&"**"!==r[u+1]&&(t+=f),i=!1})}return t}function u(e){if(!e)return null;e=e.trim();var t=_.get(e);return t?(t.regexp&&(t.regexp.lastIndex=0),t):(t=Object.create(null),p.test(e)?t.trivia=m.T1:g.test(e)?t.trivia=m.T2:v.test(e)?t.trivia=m.T3:t.regexp=c("^"+a(e)+"$"),_.set(e,t),t)}function c(e){try{return new RegExp(e)}catch(t){return/.^/}}function l(e,t,r){if(!e||!t)return!1;if("string"==typeof e){var i=u(e);if(!i)return!1;if(i.trivia===m.T1)return n.endsWith(t,e.substr(4));if(i.trivia===m.T2){var o=e.substr(3);return t===o||n.endsWith(t,"/"+o)||n.endsWith(t,"\\"+o)}return i.trivia===m.T3?e.slice(1,-1).split(",").some(function(e){return l(e,t)}):i.regexp.test(t)}return h(e,t,r)}function h(e,t,i){for(var o,s=Object.getOwnPropertyNames(e),a=function(a){var u=s[a],c=e[u];if(c===!1)return"continue";if(l(u,t)){if("boolean"==typeof c)return{value:u};if(c&&"string"==typeof c.when){if(!i||!i.length)return"continue";o||(o=n.rtrim(r.basename(t),r.extname(t)));var h=c,f=h.when.replace("$(basename)",o);return i.some(function(e){return e===f})?{value:u}:"continue"}return{value:u}}},u=0;u<s.length;u++){var c=a(u);if("object"==typeof c)return c.value}return null}var f="[/\\\\]",d="[^/\\\\]";t.splitGlobAware=s;var m,p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/[\w\.-]+$/,v=/^{\*\*\/\*\.[\w\.-]+(,\*\*\/\*\.[\w\.-]+)*}$/;!function(e){e[e.T1=0]="T1",e[e.T2=1]="T2",e[e.T3=2]="T3"}(m||(m={}));var _=new i.LinkedMap(1e4);t.match=l}),define("vs/base/common/uri",["require","exports","vs/base/common/platform"],function(e,t,n){"use strict";function r(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()}function i(e){return encodeURIComponent(e).replace(/[!'()*]/g,r)}function o(e){return e}var s=function(){function e(){this._scheme=e._empty,this._authority=e._empty,this._path=e._empty,this._query=e._empty,this._fragment=e._empty,this._formatted=null,this._fsPath=null}return Object.defineProperty(e.prototype,"scheme",{get:function(){return this._scheme},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"authority",{get:function(){return this._authority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"query",{get:function(){return this._query},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fragment",{get:function(){return this._fragment},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fsPath",{get:function(){if(!this._fsPath){var t;t=this._authority&&"file"===this.scheme?"//"+this._authority+this._path:e._driveLetterPath.test(this._path)?this._path[1].toLowerCase()+this._path.substr(2):this._path,n.isWindows&&(t=t.replace(/\//g,"\\")),this._fsPath=t}return this._fsPath},enumerable:!0,configurable:!0}),e.prototype["with"]=function(t){if(!t)return this;var n=t.scheme||this.scheme,r=t.authority||this.authority,i=t.path||this.path,o=t.query||this.query,s=t.fragment||this.fragment;if(n===this.scheme&&r===this.authority&&i===this.path&&o===this.query&&s===this.fragment)return this;var a=new e;return a._scheme=n,a._authority=r,a._path=i,a._query=o,a._fragment=s,e._validate(a),a},e.parse=function(t){var n=new e,r=e._parseComponents(t);return n._scheme=r.scheme,n._authority=decodeURIComponent(r.authority),n._path=decodeURIComponent(r.path),n._query=decodeURIComponent(r.query),n._fragment=decodeURIComponent(r.fragment),e._validate(n),n},e.file=function(t){var n=new e;if(n._scheme="file",t=t.replace(/\\/g,e._slash),t[0]===e._slash&&t[0]===t[1]){var r=t.indexOf(e._slash,2);-1===r?n._authority=t.substring(2):(n._authority=t.substring(2,r),n._path=t.substring(r))}else n._path=t;return n._path[0]!==e._slash&&(n._path=e._slash+n._path),e._validate(n),n},e._parseComponents=function(t){var n={scheme:e._empty,authority:e._empty,path:e._empty,query:e._empty,fragment:e._empty},r=e._regexp.exec(t);return r&&(n.scheme=r[2]||n.scheme,n.authority=r[4]||n.authority,n.path=r[5]||n.path,n.query=r[7]||n.query,n.fragment=r[9]||n.fragment),n},e.create=function(t,n,r,i,o){return(new e)["with"]({scheme:t,authority:n,path:r,query:i,fragment:o})},e._validate=function(e){if(e.authority&&e.path&&"/"!==e.path[0])throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');if(!e.authority&&0===e.path.indexOf("//"))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')},e.prototype.toString=function(t){return void 0===t&&(t=!1),t?e._asFormatted(this,!0):(this._formatted||(this._formatted=e._asFormatted(this,!1)),this._formatted)},e._asFormatted=function(t,n){var s=n?o:i,a=[],u=t.scheme,c=t.authority,l=t.path,h=t.query,f=t.fragment;if(u&&a.push(u,":"),(c||"file"===u)&&a.push("//"),c){c=c.toLowerCase();var d=c.indexOf(":");-1===d?a.push(s(c)):a.push(s(c.substr(0,d)),c.substr(d))}if(l){var m=e._upperCaseDrive.exec(l);m&&(l=m[1]+m[2].toLowerCase()+l.substr(m[1].length+m[2].length));for(var p=0;;){var d=l.indexOf(e._slash,p);if(-1===d){a.push(s(l.substring(p)).replace(/[#?]/,r));break}a.push(s(l.substring(p,d)).replace(/[#?]/,r),e._slash),p=d+1}}return h&&a.push("?",s(h)),f&&a.push("#",s(f)),a.join(e._empty)},e.prototype.toJSON=function(){return{scheme:this.scheme,authority:this.authority,path:this.path,fsPath:this.fsPath,query:this.query,fragment:this.fragment.replace(/URL_MARSHAL_REMOVE.*$/,""),external:this.toString().replace(/#?URL_MARSHAL_REMOVE.*$/,""),$mid:1}},e.revive=function(t){var n=new e;return n._scheme=t.scheme,n._authority=t.authority,n._path=t.path,n._query=t.query,n._fragment=t.fragment,n._fsPath=t.fsPath,n._formatted=t.external,e._validate(n),n},e._empty="",e._slash="/",e._regexp=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,e._driveLetterPath=/^\/[a-zA-z]:/,e._upperCaseDrive=/^(\/)?([A-Z]:)/,e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=s}),define("vs/editor/common/core/arrays",["require","exports"],function(e,t){"use strict";var n;!function(e){function t(e,t){var n=0,r=e.length-1;if(0>=r)return 0;for(;r>n;){var i=n+Math.ceil((r-n)/2);e[i].startIndex>t?r=i-1:n=i}return n}e.findIndexInSegmentsArray=t}(n=t.Arrays||(t.Arrays={}))}),define("vs/editor/common/core/modeTransition",["require","exports","vs/editor/common/core/arrays"],function(e,t,n){"use strict";var r=function(){function e(e,t){this.startIndex=0|e,this.mode=t,this.modeId=t.getId()}return e.findIndexInSegmentsArray=function(e,t){return n.Arrays.findIndexInSegmentsArray(e,t)},e.create=function(t){for(var n=[],r=0,i=t.length;i>r;r++){var o=t[r];n.push(new e(o.startIndex,o.mode))}return n},e}();t.ModeTransition=r}),define("vs/editor/common/core/position",["require","exports"],function(e,t){"use strict";var n=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.equals=function(t){return e.equals(this,t)},e.equals=function(e,t){return e||t?!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column:!0},e.prototype.isBefore=function(t){return e.isBefore(this,t)},e.isBefore=function(e,t){return e.lineNumber<t.lineNumber?!0:t.lineNumber<e.lineNumber?!1:e.column<t.column},e.prototype.isBeforeOrEqual=function(t){return e.isBeforeOrEqual(this,t)},e.isBeforeOrEqual=function(e,t){return e.lineNumber<t.lineNumber?!0:t.lineNumber<e.lineNumber?!1:e.column<=t.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(t){return new e(t.lineNumber,t.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e.asEmptyRange=function(e){return{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column}},e.startPosition=function(e){return{lineNumber:e.startLineNumber,column:e.startColumn}},e.endPosition=function(e){return{lineNumber:e.endLineNumber,column:e.endColumn}},e}();t.Position=n}),define("vs/editor/common/core/range",["require","exports","vs/editor/common/core/position"],function(e,t,n){"use strict";var r=function(){function e(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.prototype.containsPosition=function(t){return e.containsPosition(this,t)},e.prototype.containsRange=function(t){return e.containsRange(this,t)},e.prototype.plusRange=function(t){return e.plusRange(this,t)},e.prototype.intersectRanges=function(t){return e.intersectRanges(this,t)},e.prototype.equalsRange=function(t){return e.equalsRange(this,t)},e.prototype.getEndPosition=function(){return new n.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new n.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,n){return new e(this.startLineNumber,this.startColumn,t,n)},e.prototype.setStartPosition=function(t,n){return new e(t,n,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return new e(this.startLineNumber,this.startColumn,this.startLineNumber,this.startColumn)},e.lift=function(t){return t?new e(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null},e.isIRange=function(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn},e.isEmpty=function(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn},e.containsPosition=function(e,t){return t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber?!1:t.lineNumber===e.startLineNumber&&t.column<e.startColumn?!1:!(t.lineNumber===e.endLineNumber&&t.column>e.endColumn)},e.containsRange=function(e,t){return t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber?!1:t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber?!1:t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn?!1:!(t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)},e.areIntersectingOrTouching=function(e,t){return e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn?!1:!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)},e.intersectRanges=function(t,n){var r=t.startLineNumber,i=t.startColumn,o=t.endLineNumber,s=t.endColumn,a=n.startLineNumber,u=n.startColumn,c=n.endLineNumber,l=n.endColumn;return a>r?(r=a,i=u):r===a&&(i=Math.max(i,u)),o>c?(o=c,s=l):o===c&&(s=Math.min(s,l)),r>o?null:r===o&&i>s?null:new e(r,i,o,s)},e.plusRange=function(t,n){var r,i,o,s;return n.startLineNumber<t.startLineNumber?(r=n.startLineNumber,i=n.startColumn):n.startLineNumber===t.startLineNumber?(r=n.startLineNumber,i=Math.min(n.startColumn,t.startColumn)):(r=t.startLineNumber,i=t.startColumn),n.endLineNumber>t.endLineNumber?(o=n.endLineNumber,s=n.endColumn):n.endLineNumber===t.endLineNumber?(o=n.endLineNumber,s=Math.max(n.endColumn,t.endColumn)):(o=t.endLineNumber,s=t.endColumn),new e(r,i,o,s)},e.equalsRange=function(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn},e.compareRangesUsingStarts=function(e,t){var n=0|e.startLineNumber,r=0|t.startLineNumber,i=0|e.startColumn,o=0|t.startColumn,s=0|e.endLineNumber,a=0|t.endLineNumber,u=0|e.endColumn,c=0|t.endColumn;return n===r?i===o?s===a?u-c:s-a:i-o:n-r},e.compareRangesUsingEnds=function(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber},e.spansMultipleLines=function(e){return e.endLineNumber>e.startLineNumber},e.collapseToStart=function(e){return{startLineNumber:e.startLineNumber,startColumn:e.startColumn,endLineNumber:e.startLineNumber,endColumn:e.startColumn}},e}();t.Range=r});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/diff/diffComputer",["require","exports","vs/base/common/diff/diff","vs/base/common/strings"],function(e,t,n,r){"use strict";function i(e,t,r){var i=new n.LcsDiff(e,t,r);return i.ComputeDiff()}function o(e){if(e.length<=1)return e;var t,n,r,i,o,s,u=[e[0]],c=u[0];for(t=1,n=e.length;n>t;t++)s=e[t],r=s.originalStart-(c.originalStart+c.originalLength),i=s.modifiedStart-(c.modifiedStart+c.modifiedLength),o=Math.min(r,i),a>o?(c.originalLength=s.originalStart+s.originalLength-c.originalStart,c.modifiedLength=s.modifiedStart+s.modifiedLength-c.modifiedStart):(u.push(s),c=s);return u}var s=5e3,a=3,u=function(){function e(e,t,n){this.buffer=e,this.startMarkers=t,this.endMarkers=n}return e.prototype.equals=function(t){if(!(t instanceof e))return!1;var n=t;if(this.getLength()!==n.getLength())return!1;for(var r=0,i=this.getLength();i>r;r++){var o=this.getElementHash(r),s=n.getElementHash(r);if(o!==s)return!1}return!0},e.prototype.getLength=function(){return this.startMarkers.length},e.prototype.getElementHash=function(e){return this.buffer.substring(this.startMarkers[e].offset,this.endMarkers[e].offset)},e.prototype.getStartLineNumber=function(e){return e===this.startMarkers.length?this.startMarkers[e-1].lineNumber+1:this.startMarkers[e].lineNumber},e.prototype.getStartColumn=function(e){return this.startMarkers[e].column},e.prototype.getEndLineNumber=function(e){return this.endMarkers[e].lineNumber},e.prototype.getEndColumn=function(e){return this.endMarkers[e].column},e}(),c=function(e){function t(n,r){var i,o,s,a,u,c="",l=[],h=[];for(s=0,i=0,o=n.length;o>i;i++)c+=n[i],a=1,u=n[i].length+1,r&&(a=t._getFirstNonBlankColumn(n[i],1),u=t._getLastNonBlankColumn(n[i],1)),l.push({offset:s+a-1,lineNumber:i+1,column:a}),h.push({offset:s+u-1,lineNumber:i+1,column:u}),s+=n[i].length;e.call(this,c,l,h)}return __extends(t,e),t._getFirstNonBlankColumn=function(e,t){var n=r.firstNonWhitespaceIndex(e);return-1===n?t:n+1},t._getLastNonBlankColumn=function(e,t){var n=r.lastNonWhitespaceIndex(e);return-1===n?t:n+2},t.prototype.getCharSequence=function(e,t){var n,r,i,o,s=[],a=[];for(n=e;t>=n;n++)for(i=this.startMarkers[n],o=this.endMarkers[n],r=i.offset;r<o.offset;r++)s.push({offset:r,lineNumber:i.lineNumber,column:i.column+(r-i.offset)}),a.push({offset:r+1,lineNumber:i.lineNumber,column:i.column+(r-i.offset)+1});return new u(this.buffer,s,a)},t}(u),l=function(){function e(e,t,n){0===e.originalLength?(this.originalStartLineNumber=0,this.originalStartColumn=0,this.originalEndLineNumber=0,this.originalEndColumn=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalStartColumn=t.getStartColumn(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1),this.originalEndColumn=t.getEndColumn(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=0,this.modifiedStartColumn=0,this.modifiedEndLineNumber=0,this.modifiedEndColumn=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedStartColumn=n.getStartColumn(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1),this.modifiedEndColumn=n.getEndColumn(e.modifiedStart+e.modifiedLength-1));
}return e}(),h=function(){function e(e,t,n,r,s){if(0===e.originalLength?(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart)-1,this.originalEndLineNumber=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart)-1,this.modifiedEndLineNumber=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1)),0!==e.originalLength&&0!==e.modifiedLength&&r()){var a=t.getCharSequence(e.originalStart,e.originalStart+e.originalLength-1),u=n.getCharSequence(e.modifiedStart,e.modifiedStart+e.modifiedLength-1),c=i(a,u,r);s&&(c=o(c)),this.charChanges=[];for(var h=0,f=c.length;f>h;h++)this.charChanges.push(new l(c[h],a,u))}}return e}(),f=function(){function e(e,t,n){this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.maximumRunTimeMs=s,this.original=new c(e,this.shouldIgnoreTrimWhitespace),this.modified=new c(t,this.shouldIgnoreTrimWhitespace),n.shouldConsiderTrimWhitespaceInEmptyCase&&this.shouldIgnoreTrimWhitespace&&this.original.equals(this.modified)&&(this.shouldIgnoreTrimWhitespace=!1,this.original=new c(e,this.shouldIgnoreTrimWhitespace),this.modified=new c(t,this.shouldIgnoreTrimWhitespace))}return e.prototype.computeDiff=function(){this.computationStartTime=(new Date).getTime();for(var e=i(this.original,this.modified,this._continueProcessingPredicate.bind(this)),t=[],n=0,r=e.length;r>n;n++)t.push(new h(e[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldPostProcessCharChanges));return t},e.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var e=(new Date).getTime();return e-this.computationStartTime<this.maximumRunTimeMs},e}();t.DiffComputer=f}),define("vs/editor/common/modes/languageSelector",["require","exports","vs/base/common/glob"],function(e,t,n){"use strict";function r(e,t,n){return i(e,t,n)>0}function i(e,t,r){if(Array.isArray(e)){var o=e.map(function(e){return i(e,t,r)});return Math.max.apply(Math,o)}if("string"==typeof e)return e===r?10:"*"===e?5:0;if(e){var s=e,a=0;if(s.language)if(s.language===r)a+=10;else{if("*"!==s.language)return 0;a+=5}if(s.scheme){if(s.scheme!==t.scheme)return 0;a+=10}if(s.pattern)if(s.pattern===t.fsPath)a+=10;else{if(!n.match(s.pattern,t.fsPath))return 0;a+=5}return a}}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=r,t.score=i}),define("vs/editor/common/modes/linkComputer",["require","exports"],function(e,t){"use strict";function n(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?p.computeLinks(e):[]}var r=[],i=1,o=9,s=10;r[1]={h:2,H:2,f:11,F:11},r[2]={t:3,T:3},r[3]={t:4,T:4},r[4]={p:5,P:5},r[5]={s:6,S:6,":":7},r[6]={":":7},r[7]={"/":8},r[8]={"/":9},r[11]={i:12,I:12},r[12]={l:13,L:13},r[13]={e:6,E:6};var a;!function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"}(a||(a={}));var u="(".charCodeAt(0),c=")".charCodeAt(0),l="[".charCodeAt(0),h="]".charCodeAt(0),f="{".charCodeAt(0),d="}".charCodeAt(0),m=function(){function e(){var e=" 	<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…",t=".,;";this._asciiMap=[];for(var n=0;256>n;n++)this._asciiMap[n]=a.None;this._map=[];for(var n=0;n<e.length;n++)this._set(e.charCodeAt(n),a.ForceTermination);for(var n=0;n<t.length;n++)this._set(t.charCodeAt(n),a.CannotEndIn)}return e.prototype._set=function(e,t){256>e&&(this._asciiMap[e]=t),this._map[e]=t},e.prototype.classify=function(e){if(256>e)return this._asciiMap[e];var t=this._map[e];return t?t:a.None},e}(),p=function(){function e(){}return e._createLink=function(e,t,n,r){return{range:{startLineNumber:t,startColumn:n+1,endLineNumber:t,endColumn:r+1},url:e.substring(n,r)}},e.computeLinks=function(t){var n,m,p,g,v,_,b,C,y,x,L,N,S,E,k,I=[],w=e._characterClassifier;for(n=1,m=t.getLineCount();m>=n;n++){for(p=t.getLineContent(n),g=0,_=p.length,b=0,C=i,S=!1,E=!1,k=!1;_>g;){if(y=p.charAt(g),x=p.charCodeAt(g),N=!1,C===s){switch(x){case u:S=!0,L=a.None;break;case c:L=S?a.None:a.ForceTermination;break;case l:E=!0,L=a.None;break;case h:L=E?a.None:a.ForceTermination;break;case f:k=!0,L=a.None;break;case d:L=k?a.None:a.ForceTermination;break;default:L=w.classify(x)}if(L===a.ForceTermination){v=g-1;do{if(x=p.charCodeAt(v),L=w.classify(x),L!==a.CannotEndIn)break;v--}while(v>b);I.push(e._createLink(p,n,b,v+1)),N=!0}}else C===o?(L=w.classify(x),L===a.ForceTermination?N=!0:C=s):r[C].hasOwnProperty(y)?C=r[C][y]:N=!0;N&&(C=i,S=!1,E=!1,k=!1,b=g+1),g++}C===s&&I.push(e._createLink(p,n,b,_))}return I},e._characterClassifier=new m,e}();t.computeLinks=n}),define("vs/editor/common/modes/supports",["require","exports","vs/base/common/strings","vs/base/common/objects","vs/editor/common/core/modeTransition"],function(e,t,n,r,i){"use strict";function o(e,t,n){var r=e.modeTransitions;if(1===r.length)return n(r[0].modeId,e,t);var o=i.ModeTransition.findIndexInSegmentsArray(r,t),s=r[o].mode,a=r[o].startIndex,u=e.findIndexOfOffset(a),l=-1,h=-1;o+1<r.length?(h=e.findIndexOfOffset(r[o+1].startIndex),l=e.getTokenStartIndex(h)):(h=e.getTokenCount(),l=e.getLineContent().length);var f=e.getTokenStartIndex(u),d=new c(e,s,u,h,f,l);return n(s.getId(),d,t-f)}function s(e){return l.test(e)}var a=function(){function e(e,t){this.startIndex=e,this.type=t}return e.prototype.toString=function(){return"("+this.startIndex+", "+this.type+")"},e}();t.Token=a;var u=function(){function e(e,t,n,r){this.tokens=e,this.modeTransitions=t,this.actualStopOffset=n,this.endState=r,this.retokenize=null}return e}();t.LineTokens=u,t.handleEvent=o;var c=function(){function e(e,t,n,r,o,s){this.modeTransitions=[new i.ModeTransition(0,t)],this._actual=e,this._firstTokenInModeIndex=n,this._nextTokenAfterMode=r,this._firstTokenCharacterOffset=o,this._nextCharacterAfterModeIndex=s}return e.prototype.getLineContent=function(){var e=this._actual.getLineContent();return e.substring(this._firstTokenCharacterOffset,this._nextCharacterAfterModeIndex)},e.prototype.getTokenCount=function(){return this._nextTokenAfterMode-this._firstTokenInModeIndex},e.prototype.findIndexOfOffset=function(e){return this._actual.findIndexOfOffset(e+this._firstTokenCharacterOffset)-this._firstTokenInModeIndex},e.prototype.getTokenStartIndex=function(e){return this._actual.getTokenStartIndex(e+this._firstTokenInModeIndex)-this._firstTokenCharacterOffset},e.prototype.getTokenEndIndex=function(e){return this._actual.getTokenEndIndex(e+this._firstTokenInModeIndex)-this._firstTokenCharacterOffset},e.prototype.getTokenType=function(e){return this._actual.getTokenType(e+this._firstTokenInModeIndex)},e.prototype.getTokenText=function(e){return this._actual.getTokenText(e+this._firstTokenInModeIndex)},e}();t.FilteredLineContext=c;var l=/\b(comment|string|regex)\b/;t.ignoreBracketsInToken=s;var h=function(){function e(){}return e.registerDefaultSnippets=function(e,t){this._defaultSnippets[e]=(this._defaultSnippets[e]||[]).concat(t)},e.registerSnippets=function(e,t,n){var r=this._snippets[e];r||(this._snippets[e]=r={}),r[t]=n},e.getNonWhitespacePrefix=function(e,t){var n=e.getLineContent(t.lineNumber),r=n.match(/[^\s]+$/);return r?r[0]:""},e.getSnippets=function(t,i){var o=t.getWordAtPosition(i),s=o?o.word.substring(0,i.column-o.startColumn).toLowerCase():"",a=e.getNonWhitespacePrefix(t,i).toLowerCase(),u={currentWord:s,suggestions:[]},c=t.getModeId(),l=[],h=this._snippets[c];if(h)for(var f in h)l=l.concat(h[f]);var d=this._defaultSnippets[c];return d&&(l=l.concat(d)),l.forEach(function(e){if(0===s.length&&0===a.length);else{var t=e.label.toLowerCase();if(s.length>0&&n.startsWith(t,s));else{if(!(a.length>s.length&&n.startsWith(t,a)))return;e=r.clone(e),e.overwriteBefore=a.length}}u.suggestions.push(e)}),u},e._defaultSnippets=Object.create(null),e._snippets=Object.create(null),e}();t.SnippetsRegistry=h}),define("vs/editor/common/modes/supports/characterPair",["require","exports","vs/editor/common/modes/supports"],function(e,t,n){"use strict";var r=function(){function e(e,t,n){this._registry=e,this._modeId=t,this._autoClosingPairs=n.autoClosingPairs,this._autoClosingPairs||(this._autoClosingPairs=n.brackets?n.brackets.map(function(e){return{open:e[0],close:e[1]}}):[]),this._surroundingPairs=n.surroundingPairs||this._autoClosingPairs}return e.prototype.getAutoClosingPairs=function(){return this._autoClosingPairs},e.prototype.shouldAutoClosePair=function(e,t,r){var i=this;return n.handleEvent(t,r,function(t,n,r){if(i._modeId===t){if(0===n.getTokenCount())return!0;for(var o=n.findIndexOfOffset(r-1),s=n.getTokenType(o),a=0;a<i._autoClosingPairs.length;++a)if(i._autoClosingPairs[a].open===e){if(i._autoClosingPairs[a].notIn)for(var u=0;u<i._autoClosingPairs[a].notIn.length;++u)if(s.indexOf(i._autoClosingPairs[a].notIn[u])>-1)return!1;break}return!0}var c=i._registry.getCharacterPairSupport(t);return c?c.shouldAutoClosePair(e,n,r):null})},e.prototype.getSurroundingPairs=function(){return this._surroundingPairs},e}();t.CharacterPairSupport=r}),define("vs/editor/common/modes/supports/inplaceReplaceSupport",["require","exports"],function(e,t){"use strict";var n=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,n,r,i){if(e&&t){var o=this.doNavigateValueSet(t,i);if(o)return{range:e,value:o}}if(n&&r){var o=this.doNavigateValueSet(r,i);if(o)return{range:n,value:o}}return null},e.prototype.doNavigateValueSet=function(e,t){var n=this.numberReplace(e,t);return null!==n?n:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var n=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),r=Number(e),i=parseFloat(e);return isNaN(r)||isNaN(i)||r!==i?null:0!==r||t?(r=Math.floor(r*n),r+=t?n:-n,String(r/n)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,n){for(var r=null,i=0,o=e.length;null===r&&o>i;i++)r=this.valueSetReplace(e[i],t,n);return r},e.prototype.valueSetReplace=function(e,t,n){var r=e.indexOf(t);return r>=0?(r+=n?1:-1,0>r?r=e.length-1:r%=e.length,e[r]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=n}),define("vs/editor/common/modes/supports/richEditBrackets",["require","exports","vs/base/common/strings","vs/editor/common/core/range"],function(e,t,n,r){"use strict";function i(e,t){var n={};return function(r){var i=e(r);return n.hasOwnProperty(i)||(n[i]=t(r)),n[i]}}function o(e){var t="("+e.map(n.escapeRegExpCharacters).join(")|(")+")";return n.createRegExp(t,!0,!1,!1,!1)}function s(e){for(var t="",n=e.length-1;n>=0;n--)t+=e.charAt(n);return t}var a=function(){function e(e,t){var n=this;this.brackets=t.map(function(t){return{modeId:e,open:t[0],close:t[1],forwardRegex:u({open:t[0],close:t[1]}),reversedRegex:c({open:t[0],close:t[1]})}}),this.forwardRegex=l(this.brackets),this.reversedRegex=h(this.brackets),this.textIsBracket={},this.textIsOpenBracket={},this.maxBracketLength=0,this.brackets.forEach(function(e){n.textIsBracket[e.open]=e,n.textIsBracket[e.close]=e,n.textIsOpenBracket[e.open]=!0,n.textIsOpenBracket[e.close]=!1,n.maxBracketLength=Math.max(n.maxBracketLength,e.open.length),n.maxBracketLength=Math.max(n.maxBracketLength,e.close.length)})}return e}();t.RichEditBrackets=a;var u=i(function(e){return e.open+";"+e.close},function(e){return o([e.open,e.close])}),c=i(function(e){return e.open+";"+e.close},function(e){return o([s(e.open),s(e.close)])}),l=i(function(e){return e.map(function(e){return e.open+";"+e.close}).join(";")},function(e){var t=[];return e.forEach(function(e){t.push(e.open),t.push(e.close)}),o(t)}),h=i(function(e){return e.map(function(e){return e.open+";"+e.close}).join(";")},function(e){var t=[];return e.forEach(function(e){t.push(s(e.open)),t.push(s(e.close))}),o(t)}),f=function(){function e(){}return e._findPrevBracketInText=function(e,t,n,i){var o=n.match(e);if(!o)return null;var s=n.length-o.index,a=o[0].length,u=i+s;return new r.Range(t,u-a+1,t,u+1)},e.findPrevBracketInToken=function(e,t,n,r,i){for(var o="",s=i-1;s>=r;s--)o+=n.charAt(s);return this._findPrevBracketInText(e,t,o,r)},e.findNextBracketInText=function(e,t,n,i){var o=n.match(e);if(!o)return null;var s=o.index,a=o[0].length,u=i+s;return new r.Range(t,u+1,t,u+1+a)},e.findNextBracketInToken=function(e,t,n,r,i){var o=n.substring(r,i);return this.findNextBracketInText(e,t,o,r)},e}();t.BracketsUtils=f}),define("vs/editor/common/modes/supports/electricCharacter",["require","exports","vs/base/common/strings","vs/editor/common/modes/supports","vs/editor/common/modes/supports/richEditBrackets"],function(e,t,n,r,i){"use strict";var o=function(){function e(e,t,n,r){this._registry=e,this._modeId=t,this.contribution=r||{},this.brackets=new s(t,n,this.contribution.docComment)}return e.prototype.getElectricCharacters=function(){return Array.isArray(this.contribution.embeddedElectricCharacters)?this.contribution.embeddedElectricCharacters.concat(this.brackets.getElectricCharacters()):this.brackets.getElectricCharacters()},e.prototype.onElectricCharacter=function(e,t){var n=this;return r.handleEvent(e,t,function(e,t,r){if(n._modeId===e)return n.brackets.onElectricCharacter(t,r);var i=n._registry.getElectricCharacterSupport(e);return i?i.onElectricCharacter(t,r):null})},e}();t.BracketElectricCharacterSupport=o;var s=function(){function e(e,t,n){void 0===n&&(n=null),this._modeId=e,this._richEditBrackets=t,this._docComment=n?n:null}return e.prototype.getElectricCharacters=function(){var e=[];if(this._richEditBrackets)for(var t=0,n=this._richEditBrackets.brackets.length;n>t;t++){var r=this._richEditBrackets.brackets[t],i=r.close.charAt(r.close.length-1);e.push(i)}return this._docComment&&e.push(this._docComment.open.charAt(this._docComment.open.length-1)),e=e.filter(function(e,t,n){return n.indexOf(e)===t})},e.prototype.onElectricCharacter=function(e,t){return 0===e.getTokenCount()?null:this._onElectricCharacterDocComment(e,t)||this._onElectricCharacterStandardBrackets(e,t)},e.prototype.containsTokenTypes=function(e,t){for(var n=t.split("."),r=0;r<n.length;++r)if(e.indexOf(n[r])<0)return!1;return!0},e.prototype._onElectricCharacterStandardBrackets=function(e,t){if(!this._richEditBrackets||0===this._richEditBrackets.brackets.length)return null;var o=this._richEditBrackets.reversedRegex,s=e.getLineContent(),a=e.findIndexOfOffset(t),u=e.getTokenStartIndex(a),c=t+1,l=n.firstNonWhitespaceIndex(e.getLineContent());if(-1!==l&&u>l)return null;if(!r.ignoreBracketsInToken(e.getTokenType(a))){var h=i.BracketsUtils.findPrevBracketInToken(o,1,s,u,c);if(h){var f=s.substring(h.startColumn-1,h.endColumn-1),d=this._richEditBrackets.textIsOpenBracket[f];if(!d)return{matchOpenBracket:f}}}return null},e.prototype._onElectricCharacterDocComment=function(e,t){if(!this._docComment||!this._docComment.close)return null;var n=e.getLineContent(),r=n[t];if(r!==this._docComment.open.charAt(this._docComment.open.length-1))return null;if(n.indexOf(this._docComment.close,t)>=0)return null;var i=e.findIndexOfOffset(t);return this.containsTokenTypes(e.getTokenType(i),this._docComment.scope)?n.substring(e.getTokenStartIndex(i),t+1)!==this._docComment.open?null:{appendText:this._docComment.close}:null},e}();t.Brackets=s}),define("vs/editor/common/services/editorSimpleWorkerCommon",["require","exports"],function(e,t){"use strict";var n=function(){function e(){}return e.prototype.acceptNewModel=function(e){throw new Error("Not implemented!")},e.prototype.acceptModelChanged=function(e,t){throw new Error("Not implemented!")},e.prototype.acceptRemovedModel=function(e){throw new Error("Not implemented!")},e.prototype.computeDiff=function(e,t,n){throw new Error("Not implemented!")},e.prototype.computeDirtyDiff=function(e,t,n){throw new Error("Not implemented!")},e.prototype.computeLinks=function(e){throw new Error("Not implemented!")},e.prototype.textualSuggest=function(e,t,n,r){throw new Error("Not implemented!")},e.prototype.navigateValueSet=function(e,t,n,r,i){throw new Error("Not implemented!")},e}();t.EditorSimpleWorker=n}),define("vs/editor/common/viewModel/prefixSumComputer",["require","exports"],function(e,t){"use strict";var n=function(){function e(e,t){this.index=e,this.remainder=t}return e}();t.PrefixSumIndexOfResult=n;var r=function(){function e(e){this.values=e,this.prefixSum=[];for(var t=0,n=this.values.length;n>t;t++)this.prefixSum[t]=0;this.prefixSumValidIndex=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValue=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values.splice(e,0,t),this.prefixSum.splice(e,0,0),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.insertValues=function(t,n){t=Math.floor(t),0!==n.length&&(this.values=this.values.slice(0,t).concat(n).concat(this.values.slice(t)),this.prefixSum=this.prefixSum.slice(0,t).concat(e._zeroArray(n.length)).concat(this.prefixSum.slice(t)),t-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=t-1))},e._zeroArray=function(e){e=Math.floor(e);for(var t=[],n=0;e>n;n++)t[n]=0;return t},e.prototype.changeValue=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values[e]!==t&&(this.values[e]=t,e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1))},e.prototype.removeValues=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values.splice(e,t),this.prefixSum.splice(e,t),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this.getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(e){if(e=Math.floor(e),0>e)return 0;if(e<=this.prefixSumValidIndex)return this.prefixSum[e];var t=this.prefixSumValidIndex+1;0===t&&(this.prefixSum[0]=this.values[0],t++),e>=this.values.length&&(e=this.values.length-1);for(var n=t;e>=n;n++)this.prefixSum[n]=this.prefixSum[n-1]+this.values[n];return this.prefixSumValidIndex=Math.max(this.prefixSumValidIndex,e),this.prefixSum[e]},e.prototype.getIndexOf=function(e){e=Math.floor(e);for(var t,r,i,o=0,s=this.values.length-1;s>=o;)if(t=o+(s-o)/2|0,r=this.getAccumulatedValue(t),i=r-this.values[t],i>e)s=t-1;else{if(!(e>=r))break;o=t+1}return new n(t,e-i)},e}();t.PrefixSumComputer=r}),define("vs/editor/common/model/mirrorModel2",["require","exports","vs/editor/common/viewModel/prefixSumComputer"],function(e,t,n){"use strict";var r=function(){function e(e,t,n,r){this._uri=e,this._lines=t,this._eol=n,this._versionId=r}return e.prototype.dispose=function(){this._lines.length=0},Object.defineProperty(e.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){for(var t=null,n=0,r=e.length;r>n;n++){var i=e[n];i.eol&&(t=i.eol)}t&&t!==this._eol&&(this._eol=t,this._lineStarts=null);for(var o=-1,n=0,r=e.length;r>n;n++){var i=e[n];this._acceptDeleteRange(i.range),this._acceptInsertText({lineNumber:i.range.startLineNumber,column:i.range.startColumn},i.text),o=Math.max(o,i.versionId)}-1!==o&&(this._versionId=o)},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=[],t=this._eol.length,r=0,i=this._lines.length;i>r;r++)e.push(this._lines[r].length+t);this._lineStarts=new n.PrefixSumComputer(e)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber===e.endLineNumber){if(e.startColumn===e.endColumn)return;return void this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var n=t.split(/\r\n|\r|\n/);if(1===n.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]+this._lines[e.lineNumber-1].substring(e.column-1));n[n.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]);for(var r=new Array(n.length-1),i=1;i<n.length;i++)this._lines.splice(e.lineNumber+i-1,0,n[i]),r[i-1]=n[i].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,r)}},e}();t.MirrorModel2=r}),define("vs/base/common/callbackList",["require","exports","vs/base/common/errors"],function(e,t,n){"use strict";var r=function(){function e(){}return e.prototype.add=function(e,t,n){var r=this;void 0===t&&(t=null),this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(e),this._contexts.push(t),Array.isArray(n)&&n.push({dispose:function(){return r.remove(e,t)}})},e.prototype.remove=function(e,t){if(void 0===t&&(t=null),this._callbacks){for(var n=!1,r=0,i=this._callbacks.length;i>r;r++)if(this._callbacks[r]===e){if(this._contexts[r]===t)return this._callbacks.splice(r,1),void this._contexts.splice(r,1);n=!0}if(n)throw new Error("When adding a listener with a context, you should remove it with the same context")}},e.prototype.invoke=function(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];if(this._callbacks){for(var r=[],i=this._callbacks.slice(0),o=this._contexts.slice(0),s=0,a=i.length;a>s;s++)try{r.push(i[s].apply(o[s],e))}catch(u){n.onUnexpectedError(u)}return r}},e.prototype.isEmpty=function(){return!this._callbacks||0===this._callbacks.length},e.prototype.dispose=function(){this._callbacks=void 0,this._contexts=void 0},e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=r}),define("vs/base/common/event",["require","exports","vs/base/common/callbackList"],function(e,t,n){"use strict";function r(e,t){return function(n,r,i){var o=e.addListener2(t,function(){n.apply(r,arguments)});return Array.isArray(i)&&i.push(o),o}}function i(e,t){return function(n,r,i){return e(function(e){return n(t(e))},r,i)}}var o;!function(e){var t={dispose:function(){}};e.None=function(){return t}}(o||(o={})),Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=o;var s=function(){function e(e){this._options=e}return Object.defineProperty(e.prototype,"event",{get:function(){var t=this;return this._event||(this._event=function(r,i,o){t._callbacks||(t._callbacks=new n["default"]),t._options&&t._options.onFirstListenerAdd&&t._callbacks.isEmpty()&&t._options.onFirstListenerAdd(t),t._callbacks.add(r,i);var s;return s={dispose:function(){s.dispose=e._noop,t._disposed||(t._callbacks.remove(r,i),t._options&&t._options.onLastListenerRemove&&t._callbacks.isEmpty()&&t._options.onLastListenerRemove(t))}},Array.isArray(o)&&o.push(s),s}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(e){this._callbacks&&this._callbacks.invoke.call(this._callbacks,e)},e.prototype.dispose=function(){this._callbacks&&(this._callbacks.dispose(),this._callbacks=void 0,this._disposed=!0)},e._noop=function(){},e}();t.Emitter=s,t.fromEventEmitter=r,t.mapEvent=i;var a;!function(e){e[e.Idle=0]="Idle",e[e.Running=1]="Running"}(a||(a={}));var u=function(){function e(){this.buffers=[]}return e.prototype.wrapEvent=function(e){var t=this;return function(n,r,i){return e(function(e){var i=t.buffers[t.buffers.length-1];i?i.push(function(){return n.call(r,e)}):n.call(r,e)},void 0,i)}},e.prototype.bufferEvents=function(e){var t=[];this.buffers.push(t),e(),this.buffers.pop(),t.forEach(function(e){return e()})},e}();t.EventBufferer=u}),define("vs/editor/common/modes/languageFeatureRegistry",["require","exports","vs/base/common/event","vs/editor/common/modes/languageSelector"],function(e,t,n,r){"use strict";var i=function(){function e(){this._clock=0,this._entries=[],this._onDidChange=new n.Emitter}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),e.prototype.register=function(e,t,n){var r=this;void 0===n&&(n=!1);var i={selector:e,provider:t,isBuiltin:n,_score:-1,_time:this._clock++};return this._entries.push(i),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),{dispose:function(){if(i){var e=r._entries.indexOf(i);e>=0&&(r._entries.splice(e,1),r._lastCandidate=void 0,r._onDidChange.fire(r._entries.length),i=void 0)}}}},e.prototype.has=function(e){return this.all(e).length>0},e.prototype.all=function(e){if(!e||e.isTooLargeForHavingAMode())return[];this._updateScores(e);for(var t=[],n=0,r=this._entries;n<r.length;n++){var i=r[n];i._score>0&&t.push(i.provider)}return t},e.prototype.ordered=function(e){var t=[];return this._orderedForEach(e,function(e){return t.push(e.provider)}),t},e.prototype.orderedGroups=function(e){var t,n,r=[];return this._orderedForEach(e,function(e){t&&n===e._score?t.push(e.provider):(n=e._score,t=[e.provider],r.push(t))}),r},e.prototype._orderedForEach=function(e,t){if(e&&!e.isTooLargeForHavingAMode()){this._updateScores(e);for(var n=0;n<this._entries.length;n++){var r=this._entries[n];r._score>0&&t(r)}}},e.prototype._updateScores=function(t){var n={uri:t.uri.toString(),language:t.getModeId()};if(!this._lastCandidate||this._lastCandidate.language!==n.language||this._lastCandidate.uri!==n.uri){this._lastCandidate=n;for(var i=0,o=this._entries;i<o.length;i++){var s=o[i];s._score=r.score(s.selector,t.uri,t.getModeId()),s.isBuiltin&&s._score>0&&(s._score=.5,s._time=-1)}this._entries.sort(e._compareByScoreAndTime)}},e._compareByScoreAndTime=function(e,t){return e._score<t._score?1:e._score>t._score?-1:e._time<t._time?1:e._time>t._time?-1:0},e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i}),define("vs/editor/common/modes",["require","exports","vs/editor/common/modes/languageFeatureRegistry"],function(e,t,n){"use strict";!function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={}));t.DocumentHighlightKind;!function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null"}(t.SymbolKind||(t.SymbolKind={}));var r,r=t.SymbolKind;!function(e){function t(t){switch(t){case e.Method:return"method";case e.Function:return"function";case e.Constructor:return"constructor";case e.Variable:return"variable";case e.Class:return"class";case e.Interface:return"interface";case e.Namespace:return"namespace";case e.Package:return"package";case e.Module:return"module";case e.Property:return"property";case e.Enum:return"enum";case e.String:return"string";case e.File:return"file";case e.Array:return"array";case e.Number:return"number";case e.Boolean:return"boolean";case e.Object:return"object";case e.Key:return"key";case e.Null:return"null"}return"property"}function n(t){switch(t){case"method":return e.Method;case"function":return e.Function;case"constructor":return e.Constructor;case"variable":return e.Variable;case"class":return e.Class;case"interface":return e.Interface;case"namespace":return e.Namespace;case"package":return e.Package;case"module":return e.Module;case"property":return e.Property;case"enum":return e.Enum;case"string":return e.String;case"file":return e.File;case"array":return e.Array;case"number":return e.Number;case"boolean":return e.Boolean;case"object":return e.Object;case"key":return e.Key;case"null":return e.Null}return e.Property}e.from=t,e.to=n}(r=t.SymbolKind||(t.SymbolKind={})),function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(t.IndentAction||(t.IndentAction={}));t.IndentAction;t.ReferenceProviderRegistry=new n["default"],t.RenameProviderRegistry=new n["default"],t.SuggestRegistry=new n["default"],t.SignatureHelpProviderRegistry=new n["default"],t.HoverProviderRegistry=new n["default"],t.DocumentSymbolProviderRegistry=new n["default"],t.DocumentHighlightProviderRegistry=new n["default"],t.DefinitionProviderRegistry=new n["default"],t.CodeLensProviderRegistry=new n["default"],t.CodeActionProviderRegistry=new n["default"],t.DocumentFormattingEditProviderRegistry=new n["default"],t.DocumentRangeFormattingEditProviderRegistry=new n["default"],t.OnTypeFormattingEditProviderRegistry=new n["default"],t.LinkProviderRegistry=new n["default"]}),define("vs/editor/common/modes/supports/onEnter",["require","exports","vs/base/common/errors","vs/base/common/strings","vs/editor/common/modes","vs/editor/common/modes/supports"],function(e,t,n,r,i,o){"use strict";var s=function(){function e(t,n,r){this._registry=t,r=r||{},r.brackets=r.brackets||[["(",")"],["{","}"],["[","]"]],this._modeId=n,this._brackets=r.brackets.map(function(t){return{open:t[0],openRegExp:e._createOpenBracketRegExp(t[0]),close:t[1],closeRegExp:e._createCloseBracketRegExp(t[1])}}),this._regExpRules=r.regExpRules||[],this._indentationRules=r.indentationRules}return e.prototype.onEnter=function(e,t){var n=this,r=e.getLineContext(t.lineNumber);return o.handleEvent(r,t.column-1,function(r,i,o){if(n._modeId===r)return n._onEnter(e,t);var s=n._registry.getOnEnterSupport(r);return s?s.onEnter(e,t):null})},e.prototype._onEnter=function(e,t){var n=e.getLineContent(t.lineNumber),r=n.substr(0,t.column-1),i=n.substr(t.column-1),o=1===t.lineNumber?"":e.getLineContent(t.lineNumber-1);return this._actualOnEnter(o,r,i)},e.prototype._actualOnEnter=function(t,n,r){for(var i=0,o=this._regExpRules.length;o>i;i++){var s=this._regExpRules[i];if(s.beforeText.test(n)){if(!s.afterText)return s.action;if(s.afterText.test(r))return s.action}}if(n.length>0&&r.length>0)for(var i=0,o=this._brackets.length;o>i;i++){var a=this._brackets[i];if(a.openRegExp.test(n)&&a.closeRegExp.test(r))return e._INDENT_OUTDENT}if(this._indentationRules){if(this._indentationRules.increaseIndentPattern&&this._indentationRules.increaseIndentPattern.test(n))return e._INDENT;if(this._indentationRules.indentNextLinePattern&&this._indentationRules.indentNextLinePattern.test(n))return e._INDENT;if(/^\s/.test(n)){if(this._indentationRules.decreaseIndentPattern&&this._indentationRules.decreaseIndentPattern.test(r))return e._OUTDENT;if(this._indentationRules.indentNextLinePattern&&this._indentationRules.indentNextLinePattern.test(t))return e._OUTDENT}}if(n.length>0)for(var i=0,o=this._brackets.length;o>i;i++){var a=this._brackets[i];if(a.openRegExp.test(n))return e._INDENT}return null},e._createOpenBracketRegExp=function(t){var n=r.escapeRegExpCharacters(t);return/\B/.test(n.charAt(0))||(n="\\b"+n),n+="\\s*$",e._safeRegExp(n)},e._createCloseBracketRegExp=function(t){var n=r.escapeRegExpCharacters(t);return/\B/.test(n.charAt(n.length-1))||(n+="\\b"),n="^\\s*"+n,e._safeRegExp(n)},e._safeRegExp=function(e){try{return new RegExp(e)}catch(t){return n.onUnexpectedError(t),null}},e._INDENT={indentAction:i.IndentAction.Indent},e._INDENT_OUTDENT={indentAction:i.IndentAction.IndentOutdent},e._OUTDENT={indentAction:i.IndentAction.Outdent},e}();t.OnEnterSupport=s}),define("vs/nls!vs/editor/common/config/defaultConfig",["vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker"],function(e,t){
return e.create("vs/editor/common/config/defaultConfig",t)}),define("vs/editor/common/config/defaultConfig",["require","exports","vs/nls!vs/editor/common/config/defaultConfig","vs/base/common/platform"],function(e,t,n,r){"use strict";t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",t.DEFAULT_INDENTATION={tabSize:4,insertSpaces:!0,detectIndentation:!0},t.DEFAULT_TRIM_AUTO_WHITESPACE=!0;var i="Consolas, 'Courier New', monospace",o="Menlo, Monaco, 'Courier New', monospace",s="'Droid Sans Mono', 'Courier New', monospace, 'Droid Sans Fallback'";t.GOLDEN_LINE_HEIGHT_RATIO=r.isMacintosh?1.5:1.35;var a=function(){function e(){this.editor={experimentalScreenReader:!0,rulers:[],wordSeparators:t.USUAL_WORD_SEPARATORS,selectionClipboard:!0,ariaLabel:n.localize(0,null),lineNumbers:!0,selectOnLineNumbers:!0,lineNumbersMinChars:5,glyphMargin:!1,lineDecorationsWidth:10,revealHorizontalRightPadding:30,roundedSelection:!0,theme:"vs",readOnly:!1,scrollbar:{verticalScrollbarSize:14,horizontal:"auto",useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1},overviewRulerLanes:2,cursorBlinking:"blink",cursorStyle:"line",fontLigatures:!1,disableTranslate3d:!1,hideCursorInOverviewRuler:!1,scrollBeyondLastLine:!0,automaticLayout:!1,wrappingColumn:300,wrappingIndent:"same",wordWrapBreakBeforeCharacters:"([{‘“〈《「『【〔（［｛｢£¥＄￡￥+＋",wordWrapBreakAfterCharacters:" 	})]?|&,;¢°′″‰℃、。｡､￠，．：；？！％・･ゝゞヽヾーァィゥェォッャュョヮヵヶぁぃぅぇぉっゃゅょゎゕゖㇰㇱㇲㇳㇴㇵㇶㇷㇸㇹㇺㇻㇼㇽㇾㇿ々〻ｧｨｩｪｫｬｭｮｯｰ’”〉》」』】〕）］｝｣",wordWrapBreakObtrusiveCharacters:".",tabFocusMode:!1,hover:!0,contextmenu:!0,mouseWheelScrollSensitivity:1,quickSuggestions:!0,quickSuggestionsDelay:10,parameterHints:!0,iconsInSuggestions:!0,autoClosingBrackets:!0,formatOnType:!1,suggestOnTriggerCharacters:!0,acceptSuggestionOnEnter:!0,selectionHighlight:!0,outlineMarkers:!1,referenceInfos:!0,folding:!0,renderWhitespace:!1,indentGuides:!1,useTabStops:!0,fontFamily:r.isMacintosh?o:r.isLinux?s:i,fontSize:r.isMacintosh?12:14,lineHeight:0}}return e}();t.DefaultConfig=new a}),define("vs/editor/common/modes/nullMode",["require","exports","vs/editor/common/config/defaultConfig"],function(e,t,n){"use strict";function r(e,t,n,r,i){void 0===r&&(r=0);var o=[{startIndex:r,type:""}],s=[{startIndex:r,mode:e}];return{tokens:o,actualStopOffset:r+t.length,endState:n,modeTransitions:s}}var i=function(){function e(e,t){this.mode=e,this.stateData=t}return e.prototype.clone=function(){var t=this.stateData?this.stateData.clone():null;return new e(this.mode,t)},e.prototype.equals=function(e){if(this.mode!==e.getMode())return!1;var t=e.getStateData();return this.stateData||t?this.stateData&&t?this.stateData.equals(t):!1:!0},e.prototype.getMode=function(){return this.mode},e.prototype.tokenize=function(e){return e.advanceToEOS(),{type:""}},e.prototype.getStateData=function(){return this.stateData},e.prototype.setStateData=function(e){this.stateData=e},e}();t.NullState=i;var o=function(){function e(){}return e.createWordRegExp=function(e){void 0===e&&(e="");for(var t=n.USUAL_WORD_SEPARATORS,r="(-?\\d*\\.\\d\\w*)|([^",i=0;i<t.length;i++)e.indexOf(t[i])>=0||(r+="\\"+t[i]);return r+="\\s]+)",new RegExp(r,"g")},e.prototype.getId=function(){return e.ID},e.prototype.toSimplifiedMode=function(){return this},e.DEFAULT_WORD_REGEXP=e.createWordRegExp(),e.ID="vs.editor.modes.nullMode",e}();t.NullMode=o,t.nullTokenize=r}),define("vs/editor/common/modes/languageConfigurationRegistry",["require","exports","vs/editor/common/modes","vs/editor/common/modes/nullMode","vs/editor/common/modes/supports/characterPair","vs/editor/common/modes/supports/electricCharacter","vs/editor/common/modes/supports/onEnter","vs/editor/common/modes/supports/richEditBrackets","vs/base/common/event","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings"],function(e,t,n,r,i,o,s,a,u,c,l,h){"use strict";var f=function(){function e(n,s,u){var c=null;s&&(c=s._conf),this._conf=e._mergeConf(c,u),this._conf.brackets&&(this.brackets=new a.RichEditBrackets(n,this._conf.brackets)),this._handleOnEnter(n,this._conf),this._handleComments(n,this._conf),this._conf.autoClosingPairs&&(this.characterPair=new i.CharacterPairSupport(t.LanguageConfigurationRegistry,n,this._conf)),(this._conf.__electricCharacterSupport||this._conf.brackets)&&(this.electricCharacter=new o.BracketElectricCharacterSupport(t.LanguageConfigurationRegistry,n,this.brackets,this._conf.__electricCharacterSupport)),this.wordDefinition=this._conf.wordPattern||r.NullMode.DEFAULT_WORD_REGEXP}return e._mergeConf=function(e,t){return{comments:e?t.comments||e.comments:t.comments,brackets:e?t.brackets||e.brackets:t.brackets,wordPattern:e?t.wordPattern||e.wordPattern:t.wordPattern,indentationRules:e?t.indentationRules||e.indentationRules:t.indentationRules,onEnterRules:e?t.onEnterRules||e.onEnterRules:t.onEnterRules,autoClosingPairs:e?t.autoClosingPairs||e.autoClosingPairs:t.autoClosingPairs,surroundingPairs:e?t.surroundingPairs||e.surroundingPairs:t.surroundingPairs,__electricCharacterSupport:e?t.__electricCharacterSupport||e.__electricCharacterSupport:t.__electricCharacterSupport}},e.prototype._handleOnEnter=function(e,n){var r={},i=!0;n.brackets&&(i=!1,r.brackets=n.brackets),n.indentationRules&&(i=!1,r.indentationRules=n.indentationRules),n.onEnterRules&&(i=!1,r.regExpRules=n.onEnterRules),i||(this.onEnter=new s.OnEnterSupport(t.LanguageConfigurationRegistry,e,r))},e.prototype._handleComments=function(e,t){var n=t.comments;if(n&&(this.comments={},n.lineComment&&(this.comments.lineCommentToken=n.lineComment),n.blockComment)){var r=n.blockComment,i=r[0],o=r[1];this.comments.blockCommentStartToken=i,this.comments.blockCommentEndToken=o}},e}();t.RichEditSupport=f;var d=function(){function e(){this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._entries=Object.create(null)}return e.prototype.register=function(e,t){var n=this._entries[e]||null;return this._entries[e]=new f(e,n,t),this._onDidChange.fire(void 0),{dispose:function(){}}},e.prototype._getRichEditSupport=function(e){return this._entries[e]},e.prototype.getElectricCharacterSupport=function(e){var t=this._getRichEditSupport(e);return t?t.electricCharacter||null:null},e.prototype.getComments=function(e){var t=this._getRichEditSupport(e);return t?t.comments||null:null},e.prototype.getCharacterPairSupport=function(e){var t=this._getRichEditSupport(e);return t?t.characterPair||null:null},e.prototype.getWordDefinition=function(e){var t=this._getRichEditSupport(e);return t?t.wordDefinition||null:null},e.prototype.getOnEnterSupport=function(e){var t=this._getRichEditSupport(e);return t?t.onEnter||null:null},e.prototype.getRawEnterActionAtPosition=function(e,t,n){var r,i=this.getOnEnterSupport(e.getMode().getId());if(i)try{r=i.onEnter(e,new l.Position(t,n))}catch(o){c.onUnexpectedError(o)}return r},e.prototype.getEnterActionAtPosition=function(e,t,r){var i=e.getLineContent(t),o=h.getLeadingWhitespace(i);o.length>r-1&&(o=o.substring(0,r-1));var s=this.getRawEnterActionAtPosition(e,t,r);return s?s.appendText||(s.indentAction===n.IndentAction.Indent||s.indentAction===n.IndentAction.IndentOutdent?s.appendText="	":s.appendText=""):s={indentAction:n.IndentAction.None,appendText:""},s.removeText&&(o=o.substring(0,o.length-1)),{enterAction:s,indentation:o}},e.prototype.getBracketsSupport=function(e){var t=this._getRichEditSupport(e);return t?t.brackets||null:null},e}();t.LanguageConfigurationRegistryImpl=d,t.LanguageConfigurationRegistry=new d}),define("vs/editor/common/model/textModelWithTokensHelpers",["require","exports","vs/editor/common/modes/nullMode","vs/editor/common/core/modeTransition","vs/editor/common/modes/languageConfigurationRegistry"],function(e,t,n,r,i){"use strict";var o=function(){function e(){}return e._safeGetWordDefinition=function(e){return i.LanguageConfigurationRegistry.getWordDefinition(e.getId())},e.ensureValidWordDefinition=function(e){var t=n.NullMode.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)t=e;else{var r="g";e.ignoreCase&&(r+="i"),e.multiline&&(r+="m"),t=new RegExp(e.source,r)}return t.lastIndex=0,t},e.massageWordDefinitionOf=function(t){return e.ensureValidWordDefinition(e._safeGetWordDefinition(t))},e._getWordAtColumn=function(t,n,r,i){var o=i[r].startIndex,s=r+1<i.length?i[r+1].startIndex:t.length,a=i[r].mode;return e._getWordAtText(n,e.massageWordDefinitionOf(a),t.substring(o,s),o)},e.getWordAtPosition=function(t,n){if(!t._lineIsTokenized(n.lineNumber))return e._getWordAtText(n.column,e.massageWordDefinitionOf(t.getMode()),t.getLineContent(n.lineNumber),0);var i=null,o=t.getLineContent(n.lineNumber),s=t._getLineModeTransitions(n.lineNumber),a=n.column-1,u=r.ModeTransition.findIndexInSegmentsArray(s,a);return i=e._getWordAtColumn(o,n.column,u,s),!i&&u>0&&s[u].startIndex===a&&(i=e._getWordAtColumn(o,n.column,u-1,s)),i},e._getWordAtText=function(e,t,n,r){var i,o,s,a,u,c,l=n.match(t);if(l)for(i=0;i<l.length;i++)if(c=l[i].trim(),c.length>0&&(o=n.indexOf(c,s),s=o+c.length,a=r+o+1,u=r+s+1,e>=a&&u>=e))return{word:c,startColumn:a,endColumn:u};return null},e}();t.WordHelper=o});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/services/editorSimpleWorker",["require","exports","vs/base/common/uri","vs/base/common/winjs.base","vs/editor/common/core/range","vs/base/common/filters","vs/editor/common/diff/diffComputer","vs/editor/common/model/mirrorModel2","vs/editor/common/model/textModelWithTokensHelpers","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/services/editorSimpleWorkerCommon"],function(e,t,n,r,i,o,s,a,u,c,l,h){"use strict";function f(){return new m}var d=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var n=u.WordHelper._getWordAtText(e.column,u.WordHelper.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return n?new i.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var n=this.getWordAtPosition(e,t);return n?{word:this._lines[e.lineNumber-1].substring(n.startColumn-1,e.column-1),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype._getAllWords=function(e){var t=this,n=[];return this._lines.forEach(function(r){t._wordenize(r,e).forEach(function(e){n.push(r.substring(e.start,e.end))})}),n},t.prototype.getAllUniqueWords=function(e,t){var n=!1,r={};return this._getAllWords(e).filter(function(e){return t&&!n&&t===e?(n=!0,!1):r[e]?!1:(r[e]=!0,!0)})},t.prototype._wordenize=function(e,t){for(var n,r=[];(n=t.exec(e))&&0!==n[0].length;)r.push({start:n.index,end:n.index+n[0].length});return r},t.prototype.getValueInRange=function(e){if(e.startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,n=e.startLineNumber-1,r=e.endLineNumber-1,i=[];i.push(this._lines[n].substring(e.startColumn-1));for(var o=n+1;r>o;o++)i.push(this._lines[o]);return i.push(this._lines[r].substring(0,e.endColumn-1)),i.join(t)},t}(a.MirrorModel2),m=function(e){function t(){e.call(this),this._models=Object.create(null)}return __extends(t,e),t.prototype.acceptNewModel=function(e){this._models[e.url]=new d(n["default"].parse(e.url),e.value.lines,e.value.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){var n=this._models[e];n.onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},t.prototype.computeDiff=function(e,t,n){var i=this._models[e],o=this._models[t];if(!i||!o)return null;var a=i.getLinesContent(),u=o.getLinesContent(),c=new s.DiffComputer(a,u,{shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!0});return r.TPromise.as(c.computeDiff())},t.prototype.computeDirtyDiff=function(e,t,n){var i=this._models[e],o=this._models[t];if(!i||!o)return null;var a=i.getLinesContent(),u=o.getLinesContent(),c=new s.DiffComputer(a,u,{shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!1});return r.TPromise.as(c.computeDiff())},t.prototype.computeLinks=function(e){var t=this._models[e];return t?r.TPromise.as(c.computeLinks(t)):null},t.prototype.textualSuggest=function(e,t,n,i){var o=this._models[e];return o?r.TPromise.as(this._suggestFiltered(o,t,new RegExp(n,i))):null},t.prototype._suggestFiltered=function(e,t,n){var r=this._suggestUnfiltered(e,t,n);return[{currentWord:r.currentWord,suggestions:r.suggestions.filter(function(e){return!!o.fuzzyContiguousFilter(r.currentWord,e.label)}),incomplete:r.incomplete}]},t.prototype._suggestUnfiltered=function(e,t,n){var r=e.getWordUntilPosition(t,n).word,i=e.getAllUniqueWords(n,r),o=i.filter(function(e){return!/^-?\d*\.?\d/.test(e)}).map(function(e){return{type:"text",label:e,codeSnippet:e,noAutoAccept:!0}});return{currentWord:r,suggestions:o}},t.prototype.navigateValueSet=function(e,t,n,i,o){var s=this._models[e];if(!s)return null;var a=new RegExp(i,o);t.startColumn===t.endColumn&&(t.endColumn+=1);var u=s.getValueInRange(t),c=s.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},a),h=null;null!==c&&(h=s.getValueInRange(c));var f=l.BasicInplaceReplace.INSTANCE.navigateValueSet(t,u,c,h,n);return r.TPromise.as(f)},t}(h.EditorSimpleWorker);t.EditorSimpleWorkerImpl=m,t.create=f});
//# sourceMappingURL=../../../../../min-maps/vs/editor/common/services/editorSimpleWorker.js.map