/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.3.0(634ebbb12334e179e98d3f53c3a367443f11f3ea)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
define("vs/languages/css/common/cssTokenTypes",["require","exports"],function(e,t){"use strict";t.TOKEN_SELECTOR="entity.name.selector",t.TOKEN_SELECTOR_TAG="entity.name.tag",t.TOKEN_PROPERTY="support.type.property-name",t.TOKEN_VALUE="support.property-value",t.TOKEN_AT_KEYWORD="keyword.control.at-rule"});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},__decorate=this&&this.__decorate||function(e,t,n,r){var o,i=arguments.length,s=3>i?t:null===r?r=Object.getOwnPropertyDescriptor(t,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,r);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(3>i?o(s):i>3?o(t,n,s):o(t,n))||s);return i>3&&s&&Object.defineProperty(t,n,s),s},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/languages/css/common/css",["require","exports","vs/base/common/objects","vs/editor/common/modes","vs/platform/thread/common/threadService","vs/languages/css/common/cssTokenTypes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/modes/languageConfigurationRegistry","vs/editor/common/modes/supports/tokenizationSupport","vs/base/common/async"],function(e,t,n,r,o,i,s,a,c,u,p,l,d){"use strict";t.cssTokenTypes=i,function(e){e[e.Selector=0]="Selector",e[e.Rule=1]="Rule",e[e.Value=2]="Value",e[e.ValuePostUrl=3]="ValuePostUrl",e[e.ValueInUrlFunction=4]="ValueInUrlFunction",e[e.Unit=5]="Unit",e[e.Meta=6]="Meta",e[e.MetaPostUrl=7]="MetaPostUrl",e[e.MetaInUrlFunction=8]="MetaInUrlFunction"}(t.States||(t.States={}));var h=t.States,f=/^-?-?([a-zA-Z]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))([\w\-]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))*/,m=function(e){function t(t,n,r,o,i,s){e.call(this,t),this.kind=n,this.inComment=r,this.quote=o,this.inMeta=i,this.metaBraceCount=s}return __extends(t,e),t.prototype.nextState=function(e,t){return this.kind=e,t},t.prototype.makeClone=function(){return new t(this.getMode(),this.kind,this.inComment,this.quote,this.inMeta,this.metaBraceCount)},t.prototype.equals=function(t){return e.prototype.equals.call(this,t)&&n.equals(this,t)},t.prototype.tokenizeInComment=function(e){return/\*\/$/.test(e.advanceUntilString("*/",!0))&&(this.inComment=!1),{type:"comment.css"}},t.prototype.tokenizeInString=function(e){for(var t,n=!1,r=this.quote;!e.eos();)if(t=e.next(),n)n=!1;else if("\\"===t)n=!0;else if(t===r){this.quote=null;break}return{type:"string.css"}},t.prototype.consumeIdent=function(e){return e.goBack(1),e.advanceIfRegExp2(f)?!0:(e.advance(1),!1)},t.prototype.tokenize=function(e){if(this.inComment)return this.tokenizeInComment(e);if(null!==this.quote)return this.tokenizeInString(e);if(e.skipWhitespace2())return{type:""};if(e.advanceIfString2("/*"))return this.inComment=!0,this.tokenizeInComment(e);if(e.advanceIfString2("'"))return this.quote="'",this.tokenizeInString(e);if(e.advanceIfString2('"'))return this.quote='"',this.tokenizeInString(e);var t=e.next();switch(this.kind){case h.ValuePostUrl:if("("===t)return this.nextState(h.ValueInUrlFunction,{type:"punctuation.parenthesis.css"});this.kind=h.Value;break;case h.MetaPostUrl:if("("===t)return this.nextState(h.MetaInUrlFunction,{type:"punctuation.parenthesis.css"});this.kind=h.Meta;break;case h.ValueInUrlFunction:case h.MetaInUrlFunction:if(")"!==t)return e.advanceIfRegExp2(/^[^\)]*/),{type:"string.css"};this.kind=this.kind===h.ValueInUrlFunction?h.Value:h.Meta}switch(this.kind){case h.Selector:return"{"===t?this.nextState(h.Rule,{type:"punctuation.bracket.css"}):"("===t||")"===t?{type:"punctuation.parenthesis.css"}:"@"!==t||this.inMeta?"}"===t&&this.inMeta?(this.inMeta=!1,this.nextState(h.Selector,{type:"punctuation.bracket.css"})):/[\*\(\)\[\]\+>=\~\|;]/.test(t)?{type:"punctuation.css"}:"#"===t?(e.advanceIfRegExp2(f),{type:i.TOKEN_SELECTOR+".id.css"}):"."===t?(e.advanceIfRegExp2(f),{type:i.TOKEN_SELECTOR+".class.css"}):(this.consumeIdent(e),{type:i.TOKEN_SELECTOR_TAG+".css"}):(e.advanceIfRegExp2(f),this.nextState(h.Meta,{type:i.TOKEN_AT_KEYWORD+".css"}));case h.Meta:if("{"===t){var n=h.Rule;return this.inMeta&&(n=h.Selector),this.nextState(n,{type:"punctuation.bracket.css"})}return"("===t||")"===t?{type:"punctuation.parenthesis.css"}:";"===t?(0===this.metaBraceCount&&(this.inMeta=!1),this.nextState(h.Selector,{type:"punctuation.css"})):"u"!==t&&"U"!==t||!e.advanceIfStringCaseInsensitive2("rl")?/[\*\(\)\[\]\+>=\~\|]/.test(t)?{type:"punctuation.css"}:(this.inMeta=!0,this.consumeIdent(e),{type:i.TOKEN_VALUE+".css"}):(e.advanceIfStringCaseInsensitive2("-prefix"),this.nextState(h.MetaPostUrl,{type:i.TOKEN_VALUE+".css"}));case h.Rule:return"}"===t?this.nextState(h.Selector,{type:"punctuation.bracket.css"}):":"===t?this.nextState(h.Value,{type:"punctuation.css"}):"("===t||")"===t?{type:"punctuation.parenthesis.css"}:(this.consumeIdent(e),{type:i.TOKEN_PROPERTY+".css"});case h.Value:if("}"===t)return this.nextState(h.Selector,{type:"punctuation.bracket.css"});if(";"===t)return this.nextState(h.Rule,{type:"punctuation.css"});if(("u"===t||"U"===t)&&e.advanceIfStringCaseInsensitive2("rl"))return this.nextState(h.ValuePostUrl,{type:i.TOKEN_VALUE+".css"});if("("===t||")"===t)return{type:"punctuation.parenthesis.css"};if(","===t)return{type:"punctuation.css"};if("#"===t)return e.advanceIfRegExp2(/^[\w]*/),{type:i.TOKEN_VALUE+".hex.css"};if(/\d/.test(t)||/-|\+/.test(t)&&!e.eos()&&/\d/.test(e.peek()))return e.advanceIfRegExp2(/^[\d\.]*/),this.nextState(h.Unit,{type:i.TOKEN_VALUE+".numeric.css"});if("!"===t)return{type:i.TOKEN_VALUE+".keyword.css"};if(("i"===t||"I"===t)&&e.advanceIfStringCaseInsensitive2("mportant"))return{type:i.TOKEN_VALUE+".keyword.css"};if(this.consumeIdent(e))return{type:i.TOKEN_VALUE+".css"};break;case h.Unit:return e.goBack(1),e.advanceIfRegExp2(/^(em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)/)?{type:i.TOKEN_VALUE+".unit.css"}:(this.nextState(h.Value,null),this.tokenize(e))}return{type:""}},t}(a.AbstractState);t.State=m;var v=function(e){function t(n,o,i){var a=this;e.call(this,n.id),this._modeWorkerManager=new s.ModeWorkerManager(n,"vs/languages/css/common/cssWorker","CSSWorker",null,o),this._threadService=i,this.tokenizationSupport=new l.TokenizationSupport(this,{getInitialState:function(){return new m(a,h.Selector,!1,null,!1,0)}},!1,!1),p.LanguageConfigurationRegistry.register(this.getId(),t.LANG_CONFIG),this.inplaceReplaceSupport=this,this.configSupport=this,r.DocumentHighlightProviderRegistry.register(this.getId(),{provideDocumentHighlights:function(e,t,n){return d.wireCancellationToken(n,a._provideDocumentHighlights(e.uri,t))}},!0),r.HoverProviderRegistry.register(this.getId(),{provideHover:function(e,t,n){return d.wireCancellationToken(n,a._provideHover(e.uri,t))}},!0),r.ReferenceProviderRegistry.register(this.getId(),{provideReferences:function(e,t,n,r){return d.wireCancellationToken(r,a._provideReferences(e.uri,t))}},!0),r.DocumentSymbolProviderRegistry.register(this.getId(),{provideDocumentSymbols:function(e,t){return d.wireCancellationToken(t,a._provideDocumentSymbols(e.uri))}},!0),r.DefinitionProviderRegistry.register(this.getId(),{provideDefinition:function(e,t,n){return d.wireCancellationToken(n,a._provideDefinition(e.uri,t))}},!0),r.SuggestRegistry.register(this.getId(),{triggerCharacters:[" ",":"],shouldAutotriggerSuggest:!0,provideCompletionItems:function(e,t,n){return d.wireCancellationToken(n,a._provideCompletionItems(e.uri,t))}},!0),r.CodeActionProviderRegistry.register(this.getId(),{provideCodeActions:function(e,t,n){return d.wireCancellationToken(n,a._provideCodeActions(e.uri,t))}},!0)}return __extends(t,e),t.prototype.creationDone=function(){this._threadService.isInMainThread&&this._pickAWorkerToValidate()},t.prototype._worker=function(e){return this._modeWorkerManager.worker(e)},t.prototype.configure=function(e){return this._threadService.isInMainThread?this._configureWorkers(e):this._worker(function(t){return t._doConfigure(e)})},t.prototype._configureWorkers=function(e){return this._worker(function(t){return t._doConfigure(e)})},t.prototype.navigateValueSet=function(e,t,n){return this._worker(function(r){return r.navigateValueSet(e,t,n)})},t.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},t.prototype._provideDocumentHighlights=function(e,t){return this._worker(function(n){return n.provideDocumentHighlights(e,t)})},t.prototype._provideCompletionItems=function(e,t){return this._worker(function(n){return n.provideCompletionItems(e,t)})},t.prototype._provideDefinition=function(e,t){return this._worker(function(n){return n.provideDefinition(e,t)})},t.prototype._provideHover=function(e,t){return this._worker(function(n){return n.provideHover(e,t)})},t.prototype._provideReferences=function(e,t){return this._worker(function(n){return n.provideReferences(e,t)})},t.prototype._provideDocumentSymbols=function(e){return this._worker(function(t){return t.provideDocumentSymbols(e)})},t.prototype.findColorDeclarations=function(e){return this._worker(function(t){return t.findColorDeclarations(e)})},t.prototype._provideCodeActions=function(e,t){return this._worker(function(n){return n.provideCodeActions(e,t)})},t.LANG_CONFIG={wordPattern:/(#?-?\d*\.\d\w*%?)|((::|[@#.!:])?[\w-?]+%?)|::|[@#.!:]/g,comments:{blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string"]}]},t.$_configureWorkers=o.AllWorkersAttr(t,t.prototype._configureWorkers),t.$navigateValueSet=o.OneWorkerAttr(t,t.prototype.navigateValueSet),t.$_pickAWorkerToValidate=o.OneWorkerAttr(t,t.prototype._pickAWorkerToValidate,u.ThreadAffinity.Group1),t.$_provideDocumentHighlights=o.OneWorkerAttr(t,t.prototype._provideDocumentHighlights),t.$_provideCompletionItems=o.OneWorkerAttr(t,t.prototype._provideCompletionItems),t.$_provideDefinition=o.OneWorkerAttr(t,t.prototype._provideDefinition),t.$_provideHover=o.OneWorkerAttr(t,t.prototype._provideHover),t.$_provideReferences=o.OneWorkerAttr(t,t.prototype._provideReferences),t.$_provideDocumentSymbols=o.OneWorkerAttr(t,t.prototype._provideDocumentSymbols),t.$findColorDeclarations=o.OneWorkerAttr(t,t.prototype.findColorDeclarations),t._provideCodeActions=o.OneWorkerAttr(t,t.prototype._provideCodeActions),t=__decorate([__param(1,c.IInstantiationService),__param(2,u.IThreadService)],t)}(s.AbstractMode);t.CSSMode=v});
//# sourceMappingURL=../../../../../min-maps/vs/languages/css/common/css.js.map