/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.3.0(634ebbb12334e179e98d3f53c3a367443f11f3ea)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
define("vs/languages/html/common/htmlEmptyTagsShared",["require","exports","vs/base/common/arrays"],function(t,e,n){"use strict";function i(t){return n.binarySearch(e.EMPTY_ELEMENTS,t,function(t,e){return t.localeCompare(e)})>=0}e.EMPTY_ELEMENTS=["area","base","br","col","embed","hr","img","input","keygen","link","menuitem","meta","param","source","track","wbr"],e.isEmptyElement=i}),define("vs/languages/html/common/htmlTokenTypes",["require","exports","vs/base/common/strings"],function(t,e,n){"use strict";function i(t){return n.startsWith(t,o)}function r(t){return o+t}e.DELIM_END="punctuation.definition.meta.tag.end.html",e.DELIM_START="punctuation.definition.meta.tag.begin.html",e.DELIM_ASSIGN="meta.tag.assign.html",e.ATTRIB_NAME="entity.other.attribute-name.html",e.ATTRIB_VALUE="string.html",e.COMMENT="comment.html.content",e.DELIM_COMMENT="comment.html",e.DOCTYPE="entity.other.attribute-name.html",e.DELIM_DOCTYPE="entity.name.tag.html";var o="entity.name.tag.tag-";e.isTag=i,e.getTag=r});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,i){var r,o=arguments.length,a=3>o?e:null===i?i=Object.getOwnPropertyDescriptor(e,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(t,e,n,i);else for(var s=t.length-1;s>=0;s--)(r=t[s])&&(a=(3>o?r(a):o>3?r(e,n,a):r(e,n))||a);return o>3&&a&&Object.defineProperty(e,n,a),a},__param=this&&this.__param||function(t,e){return function(n,i){e(n,i,t)}};define("vs/languages/html/common/html",["require","exports","vs/base/common/winjs.base","vs/editor/common/modes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/thread/common/threadService","vs/editor/common/services/modeService","vs/platform/instantiation/common/instantiation","vs/languages/html/common/htmlTokenTypes","vs/languages/html/common/htmlEmptyTagsShared","vs/editor/common/modes/languageConfigurationRegistry","vs/editor/common/modes/supports/tokenizationSupport","vs/platform/thread/common/thread","vs/base/common/async"],function(t,e,n,i,r,o,a,s,u,d,c,h,p,m,l){"use strict";e.htmlTokenTypes=d,e.EMPTY_ELEMENTS=c.EMPTY_ELEMENTS,function(t){t[t.Content=0]="Content",t[t.OpeningStartTag=1]="OpeningStartTag",t[t.OpeningEndTag=2]="OpeningEndTag",t[t.WithinDoctype=3]="WithinDoctype",t[t.WithinTag=4]="WithinTag",t[t.WithinComment=5]="WithinComment",t[t.WithinEmbeddedContent=6]="WithinEmbeddedContent",t[t.AttributeName=7]="AttributeName",t[t.AttributeValue=8]="AttributeValue"}(e.States||(e.States={}));var g=e.States,f=["script","style"],v=function(t){function e(e,n,i,r,o,a,s){t.call(this,e),this.kind=n,this.lastTagName=i,this.lastAttributeName=r,this.embeddedContentType=o,this.attributeValueQuote=a,this.attributeValue=s}return __extends(e,t),e.escapeTagName=function(t){return d.getTag(t.replace(/[:_.]/g,"-"))},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},e.prototype.equals=function(n){return n instanceof e?t.prototype.equals.call(this,n)&&this.kind===n.kind&&this.lastTagName===n.lastTagName&&this.lastAttributeName===n.lastAttributeName&&this.embeddedContentType===n.embeddedContentType&&this.attributeValueQuote===n.attributeValueQuote&&this.attributeValue===n.attributeValue:!1},e.prototype.nextElementName=function(t){return t.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/).toLowerCase()},e.prototype.nextAttributeName=function(t){return t.advanceIfRegExp(/^[^\s"'>\/=\x00-\x0F\x7F\x80-\x9F]*/).toLowerCase()},e.prototype.tokenize=function(t){switch(this.kind){case g.WithinComment:if(t.advanceUntilString2("-->",!1))return{type:d.COMMENT};if(t.advanceIfString2("-->"))return this.kind=g.Content,{type:d.DELIM_COMMENT,dontMergeWithPrev:!0};break;case g.WithinDoctype:if(t.advanceUntilString2(">",!1))return{type:d.DOCTYPE};if(t.advanceIfString2(">"))return this.kind=g.Content,{type:d.DELIM_DOCTYPE,dontMergeWithPrev:!0};break;case g.Content:if(t.advanceIfCharCode2("<".charCodeAt(0))){if(!t.eos()&&"!"===t.peek()){if(t.advanceIfString2("!--"))return this.kind=g.WithinComment,{type:d.DELIM_COMMENT,dontMergeWithPrev:!0};if(t.advanceIfStringCaseInsensitive2("!DOCTYPE"))return this.kind=g.WithinDoctype,{type:d.DELIM_DOCTYPE,dontMergeWithPrev:!0}}return t.advanceIfCharCode2("/".charCodeAt(0))?(this.kind=g.OpeningEndTag,{type:d.DELIM_END,dontMergeWithPrev:!0}):(this.kind=g.OpeningStartTag,{type:d.DELIM_START,dontMergeWithPrev:!0})}break;case g.OpeningEndTag:var n=this.nextElementName(t);return n.length>0?{type:e.escapeTagName(n)}:t.advanceIfString2(">")?(this.kind=g.Content,{type:d.DELIM_END,dontMergeWithPrev:!0}):(t.advanceUntilString2(">",!1),{type:""});case g.OpeningStartTag:if(this.lastTagName=this.nextElementName(t),this.lastTagName.length>0)return this.lastAttributeName=null,"script"!==this.lastTagName&&"style"!==this.lastTagName||(this.lastAttributeName=null,this.embeddedContentType=null),this.kind=g.WithinTag,{type:e.escapeTagName(this.lastTagName)};break;case g.WithinTag:if(t.skipWhitespace2()||t.eos())return this.lastAttributeName="",{type:""};if(""===this.lastAttributeName){var i=this.nextAttributeName(t);if(i.length>0)return this.lastAttributeName=i,this.kind=g.AttributeName,{type:d.ATTRIB_NAME}}return t.advanceIfString2("/>")?(this.kind=g.Content,{type:d.DELIM_START,dontMergeWithPrev:!0}):t.advanceIfCharCode2(">".charCodeAt(0))?-1!==f.indexOf(this.lastTagName)?(this.kind=g.WithinEmbeddedContent,{type:d.DELIM_START,dontMergeWithPrev:!0}):(this.kind=g.Content,{type:d.DELIM_START,dontMergeWithPrev:!0}):(t.next2(),{type:""});case g.AttributeName:return t.skipWhitespace2()||t.eos()?{type:""}:t.advanceIfCharCode2("=".charCodeAt(0))?(this.kind=g.AttributeValue,{type:d.DELIM_ASSIGN}):(this.kind=g.WithinTag,this.lastAttributeName="",this.tokenize(t));case g.AttributeValue:if(t.eos())return{type:""};if(t.skipWhitespace2())return'"'===this.attributeValueQuote||"'"===this.attributeValueQuote?{type:d.ATTRIB_VALUE}:{type:""};if('"'!==this.attributeValueQuote&&"'"!==this.attributeValueQuote){var r=t.advanceIfRegExp(/^[^\s"'`=<>]+/);if(r.length>0)return this.kind=g.WithinTag,this.lastAttributeName=null,{type:d.ATTRIB_VALUE};var o=t.peek();return"'"===o||'"'===o?(this.attributeValueQuote=o,this.attributeValue=o,t.next2(),{type:d.ATTRIB_VALUE}):(this.kind=g.WithinTag,this.lastAttributeName=null,this.tokenize(t))}if(this.attributeValue!==this.attributeValueQuote||"script"!==this.lastTagName&&"style"!==this.lastTagName||"type"!==this.lastAttributeName){if(t.advanceIfCharCode2(this.attributeValueQuote.charCodeAt(0)))this.kind=g.WithinTag,this.attributeValue="",this.attributeValueQuote="",this.lastAttributeName=null;else{var a=t.next();this.attributeValue+=a}return{type:d.ATTRIB_VALUE}}if(this.attributeValue=t.advanceUntilString(this.attributeValueQuote,!0),this.attributeValue.length>0)return this.embeddedContentType=this.unquote(this.attributeValue),this.kind=g.WithinTag,this.attributeValue="",this.attributeValueQuote="",{type:d.ATTRIB_VALUE}}return t.next2(),this.kind=g.Content,{type:""}},e.prototype.unquote=function(t){var e=0,n=t.length;return'"'===t[0]&&e++,'"'===t[n-1]&&n--,t.substring(e,n)},e}(o.AbstractState);e.State=v;var T=function(t){function e(e,n,i,r){t.call(this,e.id),this._modeWorkerManager=this._createModeWorkerManager(e,n),this.modeService=i,this.threadService=r,this.tokenizationSupport=new p.TokenizationSupport(this,this,!0,!0),this.configSupport=this,this._registerSupports()}return __extends(e,t),e.prototype.asyncCtor=function(){return n.Promise.join([this.modeService.getOrCreateMode("text/css"),this.modeService.getOrCreateMode("text/javascript")])},e.prototype._registerSupports=function(){var t=this;if("html"!==this.getId())throw new Error("This method must be overwritten!");i.HoverProviderRegistry.register(this.getId(),{provideHover:function(e,n,i){return l.wireCancellationToken(i,t._provideHover(e.uri,n))}},!0),i.ReferenceProviderRegistry.register(this.getId(),{provideReferences:function(e,n,i,r){return l.wireCancellationToken(r,t._provideReferences(e.uri,n,i))}},!0),i.SuggestRegistry.register(this.getId(),{triggerCharacters:[".",":","<",'"',"=","/"],shouldAutotriggerSuggest:!0,provideCompletionItems:function(e,n,i){return l.wireCancellationToken(i,t._provideCompletionItems(e.uri,n))}},!0),i.DocumentHighlightProviderRegistry.register(this.getId(),{provideDocumentHighlights:function(e,n,i){return l.wireCancellationToken(i,t._provideDocumentHighlights(e.uri,n))}},!0),i.DocumentRangeFormattingEditProviderRegistry.register(this.getId(),{provideDocumentRangeFormattingEdits:function(e,n,i,r){return l.wireCancellationToken(r,t._provideDocumentRangeFormattingEdits(e.uri,n,i))}},!0),i.LinkProviderRegistry.register(this.getId(),{provideLinks:function(e,n){return l.wireCancellationToken(n,t._provideLinks(e.uri))}},!0),h.LanguageConfigurationRegistry.register(this.getId(),e.LANG_CONFIG)},e.prototype._createModeWorkerManager=function(t,e){return new r.ModeWorkerManager(t,"vs/languages/html/common/htmlWorker","HTMLWorker",null,e)},e.prototype._worker=function(t){return this._modeWorkerManager.worker(t)},e.prototype.getInitialState=function(){return new v(this,g.Content,"","","","","")},e.prototype.enterNestedMode=function(t){return t instanceof v&&t.kind===g.WithinEmbeddedContent},e.prototype.getNestedMode=function(t){var e=null,n=t,i=null;if(null!==n.embeddedContentType)this.modeService.isRegisteredMode(n.embeddedContentType)&&(e=this.modeService.getMode(n.embeddedContentType),e||(i=this.modeService.getOrCreateMode(n.embeddedContentType)));else{var r=null;r="script"===n.lastTagName?"text/javascript":"style"===n.lastTagName?"text/css":"text/plain",e=this.modeService.getMode(r)}return null===e&&(e=this.modeService.getMode("text/plain")),{mode:e,missingModePromise:i}},e.prototype.getLeavingNestedModeData=function(t,e){var n=e.lastTagName,i=new RegExp("<\\/"+n+"\\s*>","i"),r=i.exec(t);return null!==r?{nestedModeBuffer:t.substring(0,r.index),bufferAfterNestedMode:t.substring(r.index),stateAfterNestedMode:new v(this,g.Content,"","","","","")}:null},e.prototype.configure=function(t){return this.threadService.isInMainThread?this._configureWorkers(t):this._worker(function(e){return e._doConfigure(t)})},e.prototype._configureWorkers=function(t){return this._worker(function(e){return e._doConfigure(t)})},e.prototype._provideLinks=function(t){return this._worker(function(e){return e.provideLinks(t)})},e.prototype._provideDocumentRangeFormattingEdits=function(t,e,n){return this._worker(function(i){return i.provideDocumentRangeFormattingEdits(t,e,n)})},e.prototype._provideHover=function(t,e){return this._worker(function(n){return n.provideHover(t,e)})},e.prototype._provideReferences=function(t,e,n){return this._worker(function(n){return n.provideReferences(t,e)})},e.prototype._provideDocumentHighlights=function(t,e,n){return void 0===n&&(n=!1),this._worker(function(i){return i.provideDocumentHighlights(t,e,n)})},e.prototype._provideCompletionItems=function(t,e){return this._worker(function(n){return n.provideCompletionItems(t,e)})},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.LANG_CONFIG={wordPattern:r.createWordRegExp("#-?%"),comments:{blockComment:["<!--","-->"]},brackets:[["<!--","-->"],["<",">"]],__electricCharacterSupport:{embeddedElectricCharacters:["*","}","]",")"]},autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:'"',close:'"'},{open:"'",close:"'"}],onEnterRules:[{beforeText:new RegExp("<(?!(?:"+c.EMPTY_ELEMENTS.join("|")+"))([_:\\w][_:\\w-.\\d]*)([^/>]*(?!/)>)[^<]*$","i"),afterText:/^<\/([_:\w][_:\w-.\d]*)\s*>$/i,action:{indentAction:i.IndentAction.IndentOutdent}},{beforeText:new RegExp("<(?!(?:"+c.EMPTY_ELEMENTS.join("|")+"))(\\w[\\w\\d]*)([^/>]*(?!/)>)[^<]*$","i"),action:{indentAction:i.IndentAction.Indent}}]},e.$_configureWorkers=a.AllWorkersAttr(e,e.prototype._configureWorkers),e.$_provideLinks=a.OneWorkerAttr(e,e.prototype._provideLinks),e.$_provideDocumentRangeFormattingEdits=a.OneWorkerAttr(e,e.prototype._provideDocumentRangeFormattingEdits),e.$_provideHover=a.OneWorkerAttr(e,e.prototype._provideHover),e.$_provideReferences=a.OneWorkerAttr(e,e.prototype._provideReferences),e.$_provideDocumentHighlights=a.OneWorkerAttr(e,e.prototype._provideDocumentHighlights),e.$_provideCompletionItems=a.OneWorkerAttr(e,e.prototype._provideCompletionItems),e.$findColorDeclarations=a.OneWorkerAttr(e,e.prototype.findColorDeclarations),e=__decorate([__param(1,u.IInstantiationService),__param(2,s.IModeService),__param(3,m.IThreadService)],e)}(r.AbstractMode);e.HTMLMode=T});
//# sourceMappingURL=../../../../../min-maps/vs/languages/html/common/html.js.map